
from operator import attrgetter
import pyangbind.lib.xpathhelper as xpathhelper
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType, RestrictedClassType, TypedListType
from pyangbind.lib.yangtypes import YANGBool, YANGListType, YANGDynClass, ReferenceType
from pyangbind.lib.base import PybindBase
from decimal import Decimal
from bitarray import bitarray
import __builtin__
class fc_port(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module brocade-interface - based on the path /interface/fc-port. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: The list of fibrechannel interfaces in the managed
device. Each row represents a fibrechannel interface.
The list provides a way to discover all the fibrechannel interfaces
in a managed device.
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_rest_name', '_extmethods', '__name','__fc_speed_cfg','__fill_word','__long_distance','__vc_link_init','__desire_distance','__isl_r_rdy_mode','__trunk_enable','__shutdown','__config_mode','__fec_enable','__description',)

  _yang_name = 'fc-port'
  _rest_name = 'FibreChannel'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    path_helper_ = kwargs.pop("path_helper", None)
    if path_helper_ is False:
      self._path_helper = False
    elif path_helper_ is not None and isinstance(path_helper_, xpathhelper.YANGPathHelper):
      self._path_helper = path_helper_
    elif hasattr(self, "_parent"):
      path_helper_ = getattr(self._parent, "_path_helper", False)
      self._path_helper = path_helper_
    else:
      self._path_helper = False

    extmethods = kwargs.pop("extmethods", None)
    if extmethods is False:
      self._extmethods = False
    elif extmethods is not None and isinstance(extmethods, dict):
      self._extmethods = extmethods
    elif hasattr(self, "_parent"):
      extmethods = getattr(self._parent, "_extmethods", None)
      self._extmethods = extmethods
    else:
      self._extmethods = False
    self.__shutdown = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="shutdown", rest_name="shutdown", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'info': u'Shutdown the selected interface', u'cli-show-no': None, u'sort-priority': u'RUNNCFG_INTERFACE_LEVEL_SHUT_CONFIG'}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='empty', is_config=True)
    self.__fill_word = YANGDynClass(base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'idle-idle': {'value': 0}, u'arbff-arbff': {'value': 1}, u'idle-arbff': {'value': 2}, u'aa-then-ia': {'value': 3}},), default=unicode("idle-idle"), is_leaf=True, yang_name="fill-word", rest_name="fill-word", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure Fill Word', u'hidden': u'full', u'cli-suppress-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='fc-fillword-cfg-type', is_config=True)
    self.__name = YANGDynClass(base=RestrictedClassType(base_type=unicode, restriction_dict={'pattern': u'((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?(([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0-9])(:[1-4])?)', 'length': [u'3..16']}), is_leaf=True, yang_name="name", rest_name="name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-suppress-range': None, u'cli-custom-range': None}}, is_keyval=True, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='interface-type', is_config=True)
    self.__vc_link_init = YANGDynClass(base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'idle': {'value': 0}, u'arb': {'value': 1}},), default=unicode("idle"), is_leaf=True, yang_name="vc-link-init", rest_name="vc-link-init", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Enable VC Link Init', u'hidden': u'full', u'cli-suppress-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='fc-vc-link-init-cfg-type', is_config=True)
    self.__fec_enable = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="fec-enable", rest_name="fec-enable", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'info': u'Enable FEC', u'cli-show-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='empty', is_config=True)
    self.__description = YANGDynClass(base=RestrictedClassType(base_type=unicode, restriction_dict={'length': [u'1 .. 63']}), is_leaf=True, yang_name="description", rest_name="description", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Interface specific description', u'cli-multi-value': None, u'sort-priority': u'RUNNCFG_INTERFACE_LEVEL_BASIC_CONFIG'}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='string', is_config=True)
    self.__desire_distance = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="desire-distance", rest_name="desire-distance", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure Desired distance for LS and LD mode.', u'hidden': u'full', u'cli-suppress-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='desire-distance-type', is_config=True)
    self.__trunk_enable = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="trunk-enable", rest_name="trunk-enable", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'info': u'Enable Trunk', u'cli-show-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='empty', is_config=True)
    self.__fc_speed_cfg = YANGDynClass(base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'auto': {'value': 0}, u'16gbps': {'value': 7}, u'8gbps': {'value': 5}, u'4gbps': {'value': 4}, u'2gbps': {'value': 2}},), default=unicode("auto"), is_leaf=True, yang_name="fc-speed-cfg", rest_name="speed", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure Speed', u'alt-name': u'speed', u'cli-suppress-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='fc-speed-cfg-type', is_config=True)
    self.__isl_r_rdy_mode = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="isl-r_rdy-mode", rest_name="isl-r_rdy", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'info': u'Enable ISL-R_rdy Mode', u'alt-name': u'isl-r_rdy', u'cli-show-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='empty', is_config=True)
    self.__long_distance = YANGDynClass(base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'ld': {'value': 5}, u'le': {'value': 3}, u'ls': {'value': 6}, u'l0': {'value': 0}},), default=unicode("l0"), is_leaf=True, yang_name="long-distance", rest_name="long-distance", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure Long Distance', u'hidden': u'full', u'cli-suppress-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='fc-long-distance-cfg-type', is_config=True)
    self.__config_mode = YANGDynClass(base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'auto': {'value': 1}, u'nport': {'value': 3}, u'eport': {'value': 2}, u'fport': {'value': 4}},), default=unicode("auto"), is_leaf=True, yang_name="config-mode", rest_name="config-mode", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure port as  F/E/N/Auto', u'cli-incomplete-no': None, u'cli-suppress-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='interface-fc-config-mode-type', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'interface', u'fc-port']

  def _rest_path(self):
    if hasattr(self, "_parent"):
      if self._rest_name:
        return self._parent._rest_path()+[self._rest_name]
      else:
        return self._parent._rest_path()
    else:
      return [u'interface', u'FibreChannel']

  def _get_name(self):
    """
    Getter method for name, mapped from YANG variable /interface/fc_port/name (interface-type)

    YANG Description: The name of the fibrechannel interface.
    """
    return self.__name
      
  def _set_name(self, v, load=False):
    """
    Setter method for name, mapped from YANG variable /interface/fc_port/name (interface-type)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_name is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_name() directly.

    YANG Description: The name of the fibrechannel interface.
    """
    parent = getattr(self, "_parent", None)
    if parent is not None and load is False:
      raise AttributeError("Cannot set keys directly when" +
                             " within an instantiated list")

    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=unicode, restriction_dict={'pattern': u'((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?(([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0-9])(:[1-4])?)', 'length': [u'3..16']}), is_leaf=True, yang_name="name", rest_name="name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-suppress-range': None, u'cli-custom-range': None}}, is_keyval=True, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='interface-type', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """name must be of a type compatible with interface-type""",
          'defined-type': "brocade-interface:interface-type",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=unicode, restriction_dict={'pattern': u'((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?(([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0-9])(:[1-4])?)', 'length': [u'3..16']}), is_leaf=True, yang_name="name", rest_name="name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-suppress-range': None, u'cli-custom-range': None}}, is_keyval=True, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='interface-type', is_config=True)""",
        })

    self.__name = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_name(self):
    self.__name = YANGDynClass(base=RestrictedClassType(base_type=unicode, restriction_dict={'pattern': u'((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?(([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0-9])(:[1-4])?)', 'length': [u'3..16']}), is_leaf=True, yang_name="name", rest_name="name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-suppress-range': None, u'cli-custom-range': None}}, is_keyval=True, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='interface-type', is_config=True)


  def _get_fc_speed_cfg(self):
    """
    Getter method for fc_speed_cfg, mapped from YANG variable /interface/fc_port/fc_speed_cfg (fc-speed-cfg-type)
    """
    return self.__fc_speed_cfg
      
  def _set_fc_speed_cfg(self, v, load=False):
    """
    Setter method for fc_speed_cfg, mapped from YANG variable /interface/fc_port/fc_speed_cfg (fc-speed-cfg-type)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_fc_speed_cfg is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_fc_speed_cfg() directly.
    """
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'auto': {'value': 0}, u'16gbps': {'value': 7}, u'8gbps': {'value': 5}, u'4gbps': {'value': 4}, u'2gbps': {'value': 2}},), default=unicode("auto"), is_leaf=True, yang_name="fc-speed-cfg", rest_name="speed", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure Speed', u'alt-name': u'speed', u'cli-suppress-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='fc-speed-cfg-type', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """fc_speed_cfg must be of a type compatible with fc-speed-cfg-type""",
          'defined-type': "brocade-interface:fc-speed-cfg-type",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'auto': {'value': 0}, u'16gbps': {'value': 7}, u'8gbps': {'value': 5}, u'4gbps': {'value': 4}, u'2gbps': {'value': 2}},), default=unicode("auto"), is_leaf=True, yang_name="fc-speed-cfg", rest_name="speed", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure Speed', u'alt-name': u'speed', u'cli-suppress-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='fc-speed-cfg-type', is_config=True)""",
        })

    self.__fc_speed_cfg = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_fc_speed_cfg(self):
    self.__fc_speed_cfg = YANGDynClass(base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'auto': {'value': 0}, u'16gbps': {'value': 7}, u'8gbps': {'value': 5}, u'4gbps': {'value': 4}, u'2gbps': {'value': 2}},), default=unicode("auto"), is_leaf=True, yang_name="fc-speed-cfg", rest_name="speed", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure Speed', u'alt-name': u'speed', u'cli-suppress-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='fc-speed-cfg-type', is_config=True)


  def _get_fill_word(self):
    """
    Getter method for fill_word, mapped from YANG variable /interface/fc_port/fill_word (fc-fillword-cfg-type)
    """
    return self.__fill_word
      
  def _set_fill_word(self, v, load=False):
    """
    Setter method for fill_word, mapped from YANG variable /interface/fc_port/fill_word (fc-fillword-cfg-type)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_fill_word is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_fill_word() directly.
    """
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'idle-idle': {'value': 0}, u'arbff-arbff': {'value': 1}, u'idle-arbff': {'value': 2}, u'aa-then-ia': {'value': 3}},), default=unicode("idle-idle"), is_leaf=True, yang_name="fill-word", rest_name="fill-word", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure Fill Word', u'hidden': u'full', u'cli-suppress-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='fc-fillword-cfg-type', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """fill_word must be of a type compatible with fc-fillword-cfg-type""",
          'defined-type': "brocade-interface:fc-fillword-cfg-type",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'idle-idle': {'value': 0}, u'arbff-arbff': {'value': 1}, u'idle-arbff': {'value': 2}, u'aa-then-ia': {'value': 3}},), default=unicode("idle-idle"), is_leaf=True, yang_name="fill-word", rest_name="fill-word", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure Fill Word', u'hidden': u'full', u'cli-suppress-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='fc-fillword-cfg-type', is_config=True)""",
        })

    self.__fill_word = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_fill_word(self):
    self.__fill_word = YANGDynClass(base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'idle-idle': {'value': 0}, u'arbff-arbff': {'value': 1}, u'idle-arbff': {'value': 2}, u'aa-then-ia': {'value': 3}},), default=unicode("idle-idle"), is_leaf=True, yang_name="fill-word", rest_name="fill-word", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure Fill Word', u'hidden': u'full', u'cli-suppress-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='fc-fillword-cfg-type', is_config=True)


  def _get_long_distance(self):
    """
    Getter method for long_distance, mapped from YANG variable /interface/fc_port/long_distance (fc-long-distance-cfg-type)
    """
    return self.__long_distance
      
  def _set_long_distance(self, v, load=False):
    """
    Setter method for long_distance, mapped from YANG variable /interface/fc_port/long_distance (fc-long-distance-cfg-type)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_long_distance is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_long_distance() directly.
    """
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'ld': {'value': 5}, u'le': {'value': 3}, u'ls': {'value': 6}, u'l0': {'value': 0}},), default=unicode("l0"), is_leaf=True, yang_name="long-distance", rest_name="long-distance", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure Long Distance', u'hidden': u'full', u'cli-suppress-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='fc-long-distance-cfg-type', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """long_distance must be of a type compatible with fc-long-distance-cfg-type""",
          'defined-type': "brocade-interface:fc-long-distance-cfg-type",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'ld': {'value': 5}, u'le': {'value': 3}, u'ls': {'value': 6}, u'l0': {'value': 0}},), default=unicode("l0"), is_leaf=True, yang_name="long-distance", rest_name="long-distance", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure Long Distance', u'hidden': u'full', u'cli-suppress-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='fc-long-distance-cfg-type', is_config=True)""",
        })

    self.__long_distance = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_long_distance(self):
    self.__long_distance = YANGDynClass(base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'ld': {'value': 5}, u'le': {'value': 3}, u'ls': {'value': 6}, u'l0': {'value': 0}},), default=unicode("l0"), is_leaf=True, yang_name="long-distance", rest_name="long-distance", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure Long Distance', u'hidden': u'full', u'cli-suppress-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='fc-long-distance-cfg-type', is_config=True)


  def _get_vc_link_init(self):
    """
    Getter method for vc_link_init, mapped from YANG variable /interface/fc_port/vc_link_init (fc-vc-link-init-cfg-type)
    """
    return self.__vc_link_init
      
  def _set_vc_link_init(self, v, load=False):
    """
    Setter method for vc_link_init, mapped from YANG variable /interface/fc_port/vc_link_init (fc-vc-link-init-cfg-type)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_vc_link_init is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_vc_link_init() directly.
    """
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'idle': {'value': 0}, u'arb': {'value': 1}},), default=unicode("idle"), is_leaf=True, yang_name="vc-link-init", rest_name="vc-link-init", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Enable VC Link Init', u'hidden': u'full', u'cli-suppress-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='fc-vc-link-init-cfg-type', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """vc_link_init must be of a type compatible with fc-vc-link-init-cfg-type""",
          'defined-type': "brocade-interface:fc-vc-link-init-cfg-type",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'idle': {'value': 0}, u'arb': {'value': 1}},), default=unicode("idle"), is_leaf=True, yang_name="vc-link-init", rest_name="vc-link-init", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Enable VC Link Init', u'hidden': u'full', u'cli-suppress-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='fc-vc-link-init-cfg-type', is_config=True)""",
        })

    self.__vc_link_init = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_vc_link_init(self):
    self.__vc_link_init = YANGDynClass(base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'idle': {'value': 0}, u'arb': {'value': 1}},), default=unicode("idle"), is_leaf=True, yang_name="vc-link-init", rest_name="vc-link-init", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Enable VC Link Init', u'hidden': u'full', u'cli-suppress-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='fc-vc-link-init-cfg-type', is_config=True)


  def _get_desire_distance(self):
    """
    Getter method for desire_distance, mapped from YANG variable /interface/fc_port/desire_distance (desire-distance-type)
    """
    return self.__desire_distance
      
  def _set_desire_distance(self, v, load=False):
    """
    Setter method for desire_distance, mapped from YANG variable /interface/fc_port/desire_distance (desire-distance-type)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_desire_distance is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_desire_distance() directly.
    """
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="desire-distance", rest_name="desire-distance", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure Desired distance for LS and LD mode.', u'hidden': u'full', u'cli-suppress-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='desire-distance-type', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """desire_distance must be of a type compatible with desire-distance-type""",
          'defined-type': "brocade-interface:desire-distance-type",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="desire-distance", rest_name="desire-distance", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure Desired distance for LS and LD mode.', u'hidden': u'full', u'cli-suppress-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='desire-distance-type', is_config=True)""",
        })

    self.__desire_distance = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_desire_distance(self):
    self.__desire_distance = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="desire-distance", rest_name="desire-distance", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure Desired distance for LS and LD mode.', u'hidden': u'full', u'cli-suppress-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='desire-distance-type', is_config=True)


  def _get_isl_r_rdy_mode(self):
    """
    Getter method for isl_r_rdy_mode, mapped from YANG variable /interface/fc_port/isl_r_rdy_mode (empty)
    """
    return self.__isl_r_rdy_mode
      
  def _set_isl_r_rdy_mode(self, v, load=False):
    """
    Setter method for isl_r_rdy_mode, mapped from YANG variable /interface/fc_port/isl_r_rdy_mode (empty)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_isl_r_rdy_mode is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_isl_r_rdy_mode() directly.
    """
    try:
      t = YANGDynClass(v,base=YANGBool, is_leaf=True, yang_name="isl-r_rdy-mode", rest_name="isl-r_rdy", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'info': u'Enable ISL-R_rdy Mode', u'alt-name': u'isl-r_rdy', u'cli-show-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='empty', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """isl_r_rdy_mode must be of a type compatible with empty""",
          'defined-type': "empty",
          'generated-type': """YANGDynClass(base=YANGBool, is_leaf=True, yang_name="isl-r_rdy-mode", rest_name="isl-r_rdy", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'info': u'Enable ISL-R_rdy Mode', u'alt-name': u'isl-r_rdy', u'cli-show-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='empty', is_config=True)""",
        })

    self.__isl_r_rdy_mode = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_isl_r_rdy_mode(self):
    self.__isl_r_rdy_mode = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="isl-r_rdy-mode", rest_name="isl-r_rdy", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'info': u'Enable ISL-R_rdy Mode', u'alt-name': u'isl-r_rdy', u'cli-show-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='empty', is_config=True)


  def _get_trunk_enable(self):
    """
    Getter method for trunk_enable, mapped from YANG variable /interface/fc_port/trunk_enable (empty)
    """
    return self.__trunk_enable
      
  def _set_trunk_enable(self, v, load=False):
    """
    Setter method for trunk_enable, mapped from YANG variable /interface/fc_port/trunk_enable (empty)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_trunk_enable is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_trunk_enable() directly.
    """
    try:
      t = YANGDynClass(v,base=YANGBool, is_leaf=True, yang_name="trunk-enable", rest_name="trunk-enable", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'info': u'Enable Trunk', u'cli-show-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='empty', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """trunk_enable must be of a type compatible with empty""",
          'defined-type': "empty",
          'generated-type': """YANGDynClass(base=YANGBool, is_leaf=True, yang_name="trunk-enable", rest_name="trunk-enable", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'info': u'Enable Trunk', u'cli-show-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='empty', is_config=True)""",
        })

    self.__trunk_enable = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_trunk_enable(self):
    self.__trunk_enable = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="trunk-enable", rest_name="trunk-enable", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'info': u'Enable Trunk', u'cli-show-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='empty', is_config=True)


  def _get_shutdown(self):
    """
    Getter method for shutdown, mapped from YANG variable /interface/fc_port/shutdown (empty)
    """
    return self.__shutdown
      
  def _set_shutdown(self, v, load=False):
    """
    Setter method for shutdown, mapped from YANG variable /interface/fc_port/shutdown (empty)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_shutdown is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_shutdown() directly.
    """
    try:
      t = YANGDynClass(v,base=YANGBool, is_leaf=True, yang_name="shutdown", rest_name="shutdown", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'info': u'Shutdown the selected interface', u'cli-show-no': None, u'sort-priority': u'RUNNCFG_INTERFACE_LEVEL_SHUT_CONFIG'}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='empty', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """shutdown must be of a type compatible with empty""",
          'defined-type': "empty",
          'generated-type': """YANGDynClass(base=YANGBool, is_leaf=True, yang_name="shutdown", rest_name="shutdown", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'info': u'Shutdown the selected interface', u'cli-show-no': None, u'sort-priority': u'RUNNCFG_INTERFACE_LEVEL_SHUT_CONFIG'}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='empty', is_config=True)""",
        })

    self.__shutdown = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_shutdown(self):
    self.__shutdown = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="shutdown", rest_name="shutdown", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'info': u'Shutdown the selected interface', u'cli-show-no': None, u'sort-priority': u'RUNNCFG_INTERFACE_LEVEL_SHUT_CONFIG'}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='empty', is_config=True)


  def _get_config_mode(self):
    """
    Getter method for config_mode, mapped from YANG variable /interface/fc_port/config_mode (interface-fc-config-mode-type)

    YANG Description: Port Mode Configuration
    """
    return self.__config_mode
      
  def _set_config_mode(self, v, load=False):
    """
    Setter method for config_mode, mapped from YANG variable /interface/fc_port/config_mode (interface-fc-config-mode-type)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_config_mode is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_config_mode() directly.

    YANG Description: Port Mode Configuration
    """
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'auto': {'value': 1}, u'nport': {'value': 3}, u'eport': {'value': 2}, u'fport': {'value': 4}},), default=unicode("auto"), is_leaf=True, yang_name="config-mode", rest_name="config-mode", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure port as  F/E/N/Auto', u'cli-incomplete-no': None, u'cli-suppress-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='interface-fc-config-mode-type', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """config_mode must be of a type compatible with interface-fc-config-mode-type""",
          'defined-type': "brocade-interface:interface-fc-config-mode-type",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'auto': {'value': 1}, u'nport': {'value': 3}, u'eport': {'value': 2}, u'fport': {'value': 4}},), default=unicode("auto"), is_leaf=True, yang_name="config-mode", rest_name="config-mode", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure port as  F/E/N/Auto', u'cli-incomplete-no': None, u'cli-suppress-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='interface-fc-config-mode-type', is_config=True)""",
        })

    self.__config_mode = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_config_mode(self):
    self.__config_mode = YANGDynClass(base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'auto': {'value': 1}, u'nport': {'value': 3}, u'eport': {'value': 2}, u'fport': {'value': 4}},), default=unicode("auto"), is_leaf=True, yang_name="config-mode", rest_name="config-mode", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure port as  F/E/N/Auto', u'cli-incomplete-no': None, u'cli-suppress-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='interface-fc-config-mode-type', is_config=True)


  def _get_fec_enable(self):
    """
    Getter method for fec_enable, mapped from YANG variable /interface/fc_port/fec_enable (empty)
    """
    return self.__fec_enable
      
  def _set_fec_enable(self, v, load=False):
    """
    Setter method for fec_enable, mapped from YANG variable /interface/fc_port/fec_enable (empty)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_fec_enable is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_fec_enable() directly.
    """
    try:
      t = YANGDynClass(v,base=YANGBool, is_leaf=True, yang_name="fec-enable", rest_name="fec-enable", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'info': u'Enable FEC', u'cli-show-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='empty', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """fec_enable must be of a type compatible with empty""",
          'defined-type': "empty",
          'generated-type': """YANGDynClass(base=YANGBool, is_leaf=True, yang_name="fec-enable", rest_name="fec-enable", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'info': u'Enable FEC', u'cli-show-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='empty', is_config=True)""",
        })

    self.__fec_enable = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_fec_enable(self):
    self.__fec_enable = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="fec-enable", rest_name="fec-enable", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'info': u'Enable FEC', u'cli-show-no': None}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='empty', is_config=True)


  def _get_description(self):
    """
    Getter method for description, mapped from YANG variable /interface/fc_port/description (string)
    """
    return self.__description
      
  def _set_description(self, v, load=False):
    """
    Setter method for description, mapped from YANG variable /interface/fc_port/description (string)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_description is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_description() directly.
    """
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=unicode, restriction_dict={'length': [u'1 .. 63']}), is_leaf=True, yang_name="description", rest_name="description", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Interface specific description', u'cli-multi-value': None, u'sort-priority': u'RUNNCFG_INTERFACE_LEVEL_BASIC_CONFIG'}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='string', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """description must be of a type compatible with string""",
          'defined-type': "string",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=unicode, restriction_dict={'length': [u'1 .. 63']}), is_leaf=True, yang_name="description", rest_name="description", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Interface specific description', u'cli-multi-value': None, u'sort-priority': u'RUNNCFG_INTERFACE_LEVEL_BASIC_CONFIG'}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='string', is_config=True)""",
        })

    self.__description = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_description(self):
    self.__description = YANGDynClass(base=RestrictedClassType(base_type=unicode, restriction_dict={'length': [u'1 .. 63']}), is_leaf=True, yang_name="description", rest_name="description", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Interface specific description', u'cli-multi-value': None, u'sort-priority': u'RUNNCFG_INTERFACE_LEVEL_BASIC_CONFIG'}}, namespace='urn:brocade.com:mgmt:brocade-interface', defining_module='brocade-interface', yang_type='string', is_config=True)

  name = __builtin__.property(_get_name, _set_name)
  fc_speed_cfg = __builtin__.property(_get_fc_speed_cfg, _set_fc_speed_cfg)
  fill_word = __builtin__.property(_get_fill_word, _set_fill_word)
  long_distance = __builtin__.property(_get_long_distance, _set_long_distance)
  vc_link_init = __builtin__.property(_get_vc_link_init, _set_vc_link_init)
  desire_distance = __builtin__.property(_get_desire_distance, _set_desire_distance)
  isl_r_rdy_mode = __builtin__.property(_get_isl_r_rdy_mode, _set_isl_r_rdy_mode)
  trunk_enable = __builtin__.property(_get_trunk_enable, _set_trunk_enable)
  shutdown = __builtin__.property(_get_shutdown, _set_shutdown)
  config_mode = __builtin__.property(_get_config_mode, _set_config_mode)
  fec_enable = __builtin__.property(_get_fec_enable, _set_fec_enable)
  description = __builtin__.property(_get_description, _set_description)


  _pyangbind_elements = {'name': name, 'fc_speed_cfg': fc_speed_cfg, 'fill_word': fill_word, 'long_distance': long_distance, 'vc_link_init': vc_link_init, 'desire_distance': desire_distance, 'isl_r_rdy_mode': isl_r_rdy_mode, 'trunk_enable': trunk_enable, 'shutdown': shutdown, 'config_mode': config_mode, 'fec_enable': fec_enable, 'description': description, }


