
from operator import attrgetter
import pyangbind.lib.xpathhelper as xpathhelper
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType, RestrictedClassType, TypedListType
from pyangbind.lib.yangtypes import YANGBool, YANGListType, YANGDynClass, ReferenceType
from pyangbind.lib.base import PybindBase
from decimal import Decimal
from bitarray import bitarray
import __builtin__
import aging_mode
import aging_time
class host_table(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module brocade-rbridge - based on the path /rbridge-id/host-table. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_rest_name', '_extmethods', '__aging_mode','__aging_time',)

  _yang_name = 'host-table'
  _rest_name = 'host-table'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    path_helper_ = kwargs.pop("path_helper", None)
    if path_helper_ is False:
      self._path_helper = False
    elif path_helper_ is not None and isinstance(path_helper_, xpathhelper.YANGPathHelper):
      self._path_helper = path_helper_
    elif hasattr(self, "_parent"):
      path_helper_ = getattr(self._parent, "_path_helper", False)
      self._path_helper = path_helper_
    else:
      self._path_helper = False

    extmethods = kwargs.pop("extmethods", None)
    if extmethods is False:
      self._extmethods = False
    elif extmethods is not None and isinstance(extmethods, dict):
      self._extmethods = extmethods
    elif hasattr(self, "_parent"):
      extmethods = getattr(self._parent, "_extmethods", None)
      self._extmethods = extmethods
    else:
      self._extmethods = False
    self.__aging_mode = YANGDynClass(base=aging_mode.aging_mode, is_container='container', yang_name="aging-mode", rest_name="aging-mode", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Host-table Aging Mode', u'cli-incomplete-no': None, u'cli-incomplete-command': None}}, namespace='urn:brocade.com:mgmt:brocade-arp', defining_module='brocade-arp', yang_type='container', is_config=True)
    self.__aging_time = YANGDynClass(base=aging_time.aging_time, is_container='container', yang_name="aging-time", rest_name="aging-time", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Host-table Aging Time', u'cli-incomplete-no': None, u'cli-incomplete-command': None}}, namespace='urn:brocade.com:mgmt:brocade-arp', defining_module='brocade-arp', yang_type='container', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'rbridge-id', u'host-table']

  def _rest_path(self):
    if hasattr(self, "_parent"):
      if self._rest_name:
        return self._parent._rest_path()+[self._rest_name]
      else:
        return self._parent._rest_path()
    else:
      return [u'rbridge-id', u'host-table']

  def _get_aging_mode(self):
    """
    Getter method for aging_mode, mapped from YANG variable /rbridge_id/host_table/aging_mode (container)
    """
    return self.__aging_mode
      
  def _set_aging_mode(self, v, load=False):
    """
    Setter method for aging_mode, mapped from YANG variable /rbridge_id/host_table/aging_mode (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_aging_mode is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_aging_mode() directly.
    """
    try:
      t = YANGDynClass(v,base=aging_mode.aging_mode, is_container='container', yang_name="aging-mode", rest_name="aging-mode", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Host-table Aging Mode', u'cli-incomplete-no': None, u'cli-incomplete-command': None}}, namespace='urn:brocade.com:mgmt:brocade-arp', defining_module='brocade-arp', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """aging_mode must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=aging_mode.aging_mode, is_container='container', yang_name="aging-mode", rest_name="aging-mode", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Host-table Aging Mode', u'cli-incomplete-no': None, u'cli-incomplete-command': None}}, namespace='urn:brocade.com:mgmt:brocade-arp', defining_module='brocade-arp', yang_type='container', is_config=True)""",
        })

    self.__aging_mode = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_aging_mode(self):
    self.__aging_mode = YANGDynClass(base=aging_mode.aging_mode, is_container='container', yang_name="aging-mode", rest_name="aging-mode", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Host-table Aging Mode', u'cli-incomplete-no': None, u'cli-incomplete-command': None}}, namespace='urn:brocade.com:mgmt:brocade-arp', defining_module='brocade-arp', yang_type='container', is_config=True)


  def _get_aging_time(self):
    """
    Getter method for aging_time, mapped from YANG variable /rbridge_id/host_table/aging_time (container)
    """
    return self.__aging_time
      
  def _set_aging_time(self, v, load=False):
    """
    Setter method for aging_time, mapped from YANG variable /rbridge_id/host_table/aging_time (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_aging_time is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_aging_time() directly.
    """
    try:
      t = YANGDynClass(v,base=aging_time.aging_time, is_container='container', yang_name="aging-time", rest_name="aging-time", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Host-table Aging Time', u'cli-incomplete-no': None, u'cli-incomplete-command': None}}, namespace='urn:brocade.com:mgmt:brocade-arp', defining_module='brocade-arp', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """aging_time must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=aging_time.aging_time, is_container='container', yang_name="aging-time", rest_name="aging-time", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Host-table Aging Time', u'cli-incomplete-no': None, u'cli-incomplete-command': None}}, namespace='urn:brocade.com:mgmt:brocade-arp', defining_module='brocade-arp', yang_type='container', is_config=True)""",
        })

    self.__aging_time = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_aging_time(self):
    self.__aging_time = YANGDynClass(base=aging_time.aging_time, is_container='container', yang_name="aging-time", rest_name="aging-time", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Host-table Aging Time', u'cli-incomplete-no': None, u'cli-incomplete-command': None}}, namespace='urn:brocade.com:mgmt:brocade-arp', defining_module='brocade-arp', yang_type='container', is_config=True)

  aging_mode = __builtin__.property(_get_aging_mode, _set_aging_mode)
  aging_time = __builtin__.property(_get_aging_time, _set_aging_time)


  _pyangbind_elements = {'aging_mode': aging_mode, 'aging_time': aging_time, }


