
from operator import attrgetter
import pyangbind.lib.xpathhelper as xpathhelper
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType, RestrictedClassType, TypedListType
from pyangbind.lib.yangtypes import YANGBool, YANGListType, YANGDynClass, ReferenceType
from pyangbind.lib.base import PybindBase
from decimal import Decimal
from bitarray import bitarray
import __builtin__
import metric
import area_default_information_originate
class nssa(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module brocade-rbridge - based on the path /rbridge-id/ipv6/router/ospf/area/nssa. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Specify the area as a Not-So-Stubby Area.NSSA allows to configure OSPF areas that provide the benefits of stub areas, but that also are capable of importing external route information. OSPF does not flood external routes from other areas into an NSSA, but does translate and flood route information from the NSSA into other areas such as the backbone. NSSAs are especially useful to summarize Type-5 External LSAs (external routes) before forwarding them into an area. The OSPF specification (RFC 2328) prohibits summarization of Type-5 LSAs and requires OSPF to flood Type-5 LSAs throughout a routing domain. With NSSA, it is possible specify an address range for aggregating the external routes that the NSSAs ABR exports into other areas.Since the NSSA is partially 'stubby' the ABR does not flood external LSAs from the backbone into the NSSA.To provide access to the rest of the Autonomous System (AS), the ABR generates a default Type-7 LSA into the NSSA.
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_rest_name', '_extmethods', '__metric','__area_default_information_originate','__no_redistribution','__nssa_area_no_summary','__translator_always','__translator_interval',)

  _yang_name = 'nssa'
  _rest_name = 'nssa'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    path_helper_ = kwargs.pop("path_helper", None)
    if path_helper_ is False:
      self._path_helper = False
    elif path_helper_ is not None and isinstance(path_helper_, xpathhelper.YANGPathHelper):
      self._path_helper = path_helper_
    elif hasattr(self, "_parent"):
      path_helper_ = getattr(self._parent, "_path_helper", False)
      self._path_helper = path_helper_
    else:
      self._path_helper = False

    extmethods = kwargs.pop("extmethods", None)
    if extmethods is False:
      self._extmethods = False
    elif extmethods is not None and isinstance(extmethods, dict):
      self._extmethods = extmethods
    elif hasattr(self, "_parent"):
      extmethods = getattr(self._parent, "_extmethods", None)
      self._extmethods = extmethods
    else:
      self._extmethods = False
    self.__area_default_information_originate = YANGDynClass(base=area_default_information_originate.area_default_information_originate, is_container='container', yang_name="area-default-information-originate", rest_name="default-information-originate", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-compact-syntax': None, u'info': u'Control distribution of default information', u'alt-name': u'default-information-originate'}}, namespace='urn:brocade.com:mgmt:brocade-ospfv3', defining_module='brocade-ospfv3', yang_type='container', is_config=True)
    self.__metric = YANGDynClass(base=metric.metric, is_container='container', yang_name="metric", rest_name="", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-drop-node-name': None, u'cli-sequence-commands': None}}, namespace='urn:brocade.com:mgmt:brocade-ospfv3', defining_module='brocade-ospfv3', yang_type='container', is_config=True)
    self.__translator_interval = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': [u'10..60']}), is_leaf=True, yang_name="translator-interval", rest_name="translator-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Set nssa translator stability interval'}}, namespace='urn:brocade.com:mgmt:brocade-ospfv3', defining_module='brocade-ospfv3', yang_type='common-def:time-interval-sec', is_config=True)
    self.__no_redistribution = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="no-redistribution", rest_name="no-redistribution", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Do not send redistributed LSA into nssa area'}}, namespace='urn:brocade.com:mgmt:brocade-ospfv3', defining_module='brocade-ospfv3', yang_type='empty', is_config=True)
    self.__translator_always = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="translator-always", rest_name="translator-always", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Set nssa translator role'}}, namespace='urn:brocade.com:mgmt:brocade-ospfv3', defining_module='brocade-ospfv3', yang_type='empty', is_config=True)
    self.__nssa_area_no_summary = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="nssa-area-no-summary", rest_name="no-summary", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Do not send summary LSA into nssa area', u'alt-name': u'no-summary'}}, namespace='urn:brocade.com:mgmt:brocade-ospfv3', defining_module='brocade-ospfv3', yang_type='empty', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'rbridge-id', u'ipv6', u'router', u'ospf', u'area', u'nssa']

  def _rest_path(self):
    if hasattr(self, "_parent"):
      if self._rest_name:
        return self._parent._rest_path()+[self._rest_name]
      else:
        return self._parent._rest_path()
    else:
      return [u'rbridge-id', u'ipv6', u'router', u'ospf', u'area', u'nssa']

  def _get_metric(self):
    """
    Getter method for metric, mapped from YANG variable /rbridge_id/ipv6/router/ospf/area/nssa/metric (container)
    """
    return self.__metric
      
  def _set_metric(self, v, load=False):
    """
    Setter method for metric, mapped from YANG variable /rbridge_id/ipv6/router/ospf/area/nssa/metric (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_metric is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_metric() directly.
    """
    try:
      t = YANGDynClass(v,base=metric.metric, is_container='container', yang_name="metric", rest_name="", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-drop-node-name': None, u'cli-sequence-commands': None}}, namespace='urn:brocade.com:mgmt:brocade-ospfv3', defining_module='brocade-ospfv3', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """metric must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=metric.metric, is_container='container', yang_name="metric", rest_name="", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-drop-node-name': None, u'cli-sequence-commands': None}}, namespace='urn:brocade.com:mgmt:brocade-ospfv3', defining_module='brocade-ospfv3', yang_type='container', is_config=True)""",
        })

    self.__metric = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_metric(self):
    self.__metric = YANGDynClass(base=metric.metric, is_container='container', yang_name="metric", rest_name="", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-drop-node-name': None, u'cli-sequence-commands': None}}, namespace='urn:brocade.com:mgmt:brocade-ospfv3', defining_module='brocade-ospfv3', yang_type='container', is_config=True)


  def _get_area_default_information_originate(self):
    """
    Getter method for area_default_information_originate, mapped from YANG variable /rbridge_id/ipv6/router/ospf/area/nssa/area_default_information_originate (container)

    YANG Description: This parameter generates a default route into an NSSA. If no-summary option is enabled then a type-3 default LSA will be generated into NSSA else a type-7 LSA will begenerated into NSSA. By default the default-information-origiante parameter is not set.
    """
    return self.__area_default_information_originate
      
  def _set_area_default_information_originate(self, v, load=False):
    """
    Setter method for area_default_information_originate, mapped from YANG variable /rbridge_id/ipv6/router/ospf/area/nssa/area_default_information_originate (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_area_default_information_originate is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_area_default_information_originate() directly.

    YANG Description: This parameter generates a default route into an NSSA. If no-summary option is enabled then a type-3 default LSA will be generated into NSSA else a type-7 LSA will begenerated into NSSA. By default the default-information-origiante parameter is not set.
    """
    try:
      t = YANGDynClass(v,base=area_default_information_originate.area_default_information_originate, is_container='container', yang_name="area-default-information-originate", rest_name="default-information-originate", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-compact-syntax': None, u'info': u'Control distribution of default information', u'alt-name': u'default-information-originate'}}, namespace='urn:brocade.com:mgmt:brocade-ospfv3', defining_module='brocade-ospfv3', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """area_default_information_originate must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=area_default_information_originate.area_default_information_originate, is_container='container', yang_name="area-default-information-originate", rest_name="default-information-originate", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-compact-syntax': None, u'info': u'Control distribution of default information', u'alt-name': u'default-information-originate'}}, namespace='urn:brocade.com:mgmt:brocade-ospfv3', defining_module='brocade-ospfv3', yang_type='container', is_config=True)""",
        })

    self.__area_default_information_originate = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_area_default_information_originate(self):
    self.__area_default_information_originate = YANGDynClass(base=area_default_information_originate.area_default_information_originate, is_container='container', yang_name="area-default-information-originate", rest_name="default-information-originate", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-compact-syntax': None, u'info': u'Control distribution of default information', u'alt-name': u'default-information-originate'}}, namespace='urn:brocade.com:mgmt:brocade-ospfv3', defining_module='brocade-ospfv3', yang_type='container', is_config=True)


  def _get_no_redistribution(self):
    """
    Getter method for no_redistribution, mapped from YANG variable /rbridge_id/ipv6/router/ospf/area/nssa/no_redistribution (empty)

    YANG Description: To disable sending redistributed LSA into nssa areaThis parameter prevents an NSSA ABR from generating external (type-7) LSA into an NSSA area. This is used in the case where an ASBR should generate type-5 LSA into normal areas and should not generate type-7 LSA into NSSA area. By default, redistribution is enabled in a NSSA.
    """
    return self.__no_redistribution
      
  def _set_no_redistribution(self, v, load=False):
    """
    Setter method for no_redistribution, mapped from YANG variable /rbridge_id/ipv6/router/ospf/area/nssa/no_redistribution (empty)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_no_redistribution is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_no_redistribution() directly.

    YANG Description: To disable sending redistributed LSA into nssa areaThis parameter prevents an NSSA ABR from generating external (type-7) LSA into an NSSA area. This is used in the case where an ASBR should generate type-5 LSA into normal areas and should not generate type-7 LSA into NSSA area. By default, redistribution is enabled in a NSSA.
    """
    try:
      t = YANGDynClass(v,base=YANGBool, is_leaf=True, yang_name="no-redistribution", rest_name="no-redistribution", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Do not send redistributed LSA into nssa area'}}, namespace='urn:brocade.com:mgmt:brocade-ospfv3', defining_module='brocade-ospfv3', yang_type='empty', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """no_redistribution must be of a type compatible with empty""",
          'defined-type': "empty",
          'generated-type': """YANGDynClass(base=YANGBool, is_leaf=True, yang_name="no-redistribution", rest_name="no-redistribution", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Do not send redistributed LSA into nssa area'}}, namespace='urn:brocade.com:mgmt:brocade-ospfv3', defining_module='brocade-ospfv3', yang_type='empty', is_config=True)""",
        })

    self.__no_redistribution = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_no_redistribution(self):
    self.__no_redistribution = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="no-redistribution", rest_name="no-redistribution", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Do not send redistributed LSA into nssa area'}}, namespace='urn:brocade.com:mgmt:brocade-ospfv3', defining_module='brocade-ospfv3', yang_type='empty', is_config=True)


  def _get_nssa_area_no_summary(self):
    """
    Getter method for nssa_area_no_summary, mapped from YANG variable /rbridge_id/ipv6/router/ospf/area/nssa/nssa_area_no_summary (empty)

    YANG Description: To disable sending summary LSA into nssa areaThis parameter prevents an NSSA ABR from generating a type-3 summary into an NSSA.By default the summary LSA is originated into NSSA.
    """
    return self.__nssa_area_no_summary
      
  def _set_nssa_area_no_summary(self, v, load=False):
    """
    Setter method for nssa_area_no_summary, mapped from YANG variable /rbridge_id/ipv6/router/ospf/area/nssa/nssa_area_no_summary (empty)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_nssa_area_no_summary is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_nssa_area_no_summary() directly.

    YANG Description: To disable sending summary LSA into nssa areaThis parameter prevents an NSSA ABR from generating a type-3 summary into an NSSA.By default the summary LSA is originated into NSSA.
    """
    try:
      t = YANGDynClass(v,base=YANGBool, is_leaf=True, yang_name="nssa-area-no-summary", rest_name="no-summary", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Do not send summary LSA into nssa area', u'alt-name': u'no-summary'}}, namespace='urn:brocade.com:mgmt:brocade-ospfv3', defining_module='brocade-ospfv3', yang_type='empty', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """nssa_area_no_summary must be of a type compatible with empty""",
          'defined-type': "empty",
          'generated-type': """YANGDynClass(base=YANGBool, is_leaf=True, yang_name="nssa-area-no-summary", rest_name="no-summary", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Do not send summary LSA into nssa area', u'alt-name': u'no-summary'}}, namespace='urn:brocade.com:mgmt:brocade-ospfv3', defining_module='brocade-ospfv3', yang_type='empty', is_config=True)""",
        })

    self.__nssa_area_no_summary = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_nssa_area_no_summary(self):
    self.__nssa_area_no_summary = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="nssa-area-no-summary", rest_name="no-summary", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Do not send summary LSA into nssa area', u'alt-name': u'no-summary'}}, namespace='urn:brocade.com:mgmt:brocade-ospfv3', defining_module='brocade-ospfv3', yang_type='empty', is_config=True)


  def _get_translator_always(self):
    """
    Getter method for translator_always, mapped from YANG variable /rbridge_id/ipv6/router/ospf/area/nssa/translator_always (empty)

    YANG Description: Set nssa translator roleWhen configured on an ABR, this causes the router to unconditionally assume the role of an NSSA translator.By default, translator-always is not set, the translator role by default is candidate.
    """
    return self.__translator_always
      
  def _set_translator_always(self, v, load=False):
    """
    Setter method for translator_always, mapped from YANG variable /rbridge_id/ipv6/router/ospf/area/nssa/translator_always (empty)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_translator_always is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_translator_always() directly.

    YANG Description: Set nssa translator roleWhen configured on an ABR, this causes the router to unconditionally assume the role of an NSSA translator.By default, translator-always is not set, the translator role by default is candidate.
    """
    try:
      t = YANGDynClass(v,base=YANGBool, is_leaf=True, yang_name="translator-always", rest_name="translator-always", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Set nssa translator role'}}, namespace='urn:brocade.com:mgmt:brocade-ospfv3', defining_module='brocade-ospfv3', yang_type='empty', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """translator_always must be of a type compatible with empty""",
          'defined-type': "empty",
          'generated-type': """YANGDynClass(base=YANGBool, is_leaf=True, yang_name="translator-always", rest_name="translator-always", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Set nssa translator role'}}, namespace='urn:brocade.com:mgmt:brocade-ospfv3', defining_module='brocade-ospfv3', yang_type='empty', is_config=True)""",
        })

    self.__translator_always = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_translator_always(self):
    self.__translator_always = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="translator-always", rest_name="translator-always", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Set nssa translator role'}}, namespace='urn:brocade.com:mgmt:brocade-ospfv3', defining_module='brocade-ospfv3', yang_type='empty', is_config=True)


  def _get_translator_interval(self):
    """
    Getter method for translator_interval, mapped from YANG variable /rbridge_id/ipv6/router/ospf/area/nssa/translator_interval (common-def:time-interval-sec)

    YANG Description: The time interval for which an elected NSSA translator continues to perform its duties evenafter its NSSA translator role has been deposed by another router
    """
    return self.__translator_interval
      
  def _set_translator_interval(self, v, load=False):
    """
    Setter method for translator_interval, mapped from YANG variable /rbridge_id/ipv6/router/ospf/area/nssa/translator_interval (common-def:time-interval-sec)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_translator_interval is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_translator_interval() directly.

    YANG Description: The time interval for which an elected NSSA translator continues to perform its duties evenafter its NSSA translator role has been deposed by another router
    """
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': [u'10..60']}), is_leaf=True, yang_name="translator-interval", rest_name="translator-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Set nssa translator stability interval'}}, namespace='urn:brocade.com:mgmt:brocade-ospfv3', defining_module='brocade-ospfv3', yang_type='common-def:time-interval-sec', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """translator_interval must be of a type compatible with common-def:time-interval-sec""",
          'defined-type': "common-def:time-interval-sec",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': [u'10..60']}), is_leaf=True, yang_name="translator-interval", rest_name="translator-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Set nssa translator stability interval'}}, namespace='urn:brocade.com:mgmt:brocade-ospfv3', defining_module='brocade-ospfv3', yang_type='common-def:time-interval-sec', is_config=True)""",
        })

    self.__translator_interval = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_translator_interval(self):
    self.__translator_interval = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': [u'10..60']}), is_leaf=True, yang_name="translator-interval", rest_name="translator-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Set nssa translator stability interval'}}, namespace='urn:brocade.com:mgmt:brocade-ospfv3', defining_module='brocade-ospfv3', yang_type='common-def:time-interval-sec', is_config=True)

  metric = __builtin__.property(_get_metric, _set_metric)
  area_default_information_originate = __builtin__.property(_get_area_default_information_originate, _set_area_default_information_originate)
  no_redistribution = __builtin__.property(_get_no_redistribution, _set_no_redistribution)
  nssa_area_no_summary = __builtin__.property(_get_nssa_area_no_summary, _set_nssa_area_no_summary)
  translator_always = __builtin__.property(_get_translator_always, _set_translator_always)
  translator_interval = __builtin__.property(_get_translator_interval, _set_translator_interval)


  _pyangbind_elements = {'metric': metric, 'area_default_information_originate': area_default_information_originate, 'no_redistribution': no_redistribution, 'nssa_area_no_summary': nssa_area_no_summary, 'translator_always': translator_always, 'translator_interval': translator_interval, }


