
from operator import attrgetter
import pyangbind.lib.xpathhelper as xpathhelper
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType, RestrictedClassType, TypedListType
from pyangbind.lib.yangtypes import YANGBool, YANGListType, YANGDynClass, ReferenceType
from pyangbind.lib.base import PybindBase
from decimal import Decimal
from bitarray import bitarray
import __builtin__
import logical_instance
class openflow(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module brocade-rbridge - based on the path /rbridge-id/openflow. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: OpenFlow configuration.
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_rest_name', '_extmethods', '__logical_instance',)

  _yang_name = 'openflow'
  _rest_name = 'openflow'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    path_helper_ = kwargs.pop("path_helper", None)
    if path_helper_ is False:
      self._path_helper = False
    elif path_helper_ is not None and isinstance(path_helper_, xpathhelper.YANGPathHelper):
      self._path_helper = path_helper_
    elif hasattr(self, "_parent"):
      path_helper_ = getattr(self._parent, "_path_helper", False)
      self._path_helper = path_helper_
    else:
      self._path_helper = False

    extmethods = kwargs.pop("extmethods", None)
    if extmethods is False:
      self._extmethods = False
    elif extmethods is not None and isinstance(extmethods, dict):
      self._extmethods = extmethods
    elif hasattr(self, "_parent"):
      extmethods = getattr(self._parent, "_extmethods", None)
      self._extmethods = extmethods
    else:
      self._extmethods = False
    self.__logical_instance = YANGDynClass(base=YANGListType("instance_id",logical_instance.logical_instance, yang_name="logical-instance", rest_name="logical-instance", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='instance-id', extensions={u'tailf-common': {u'info': u'OpenFlow logical instance configuration', u'callpoint': u'OpenFlowLogicalInstance'}}), is_container='list', yang_name="logical-instance", rest_name="logical-instance", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'OpenFlow logical instance configuration', u'callpoint': u'OpenFlowLogicalInstance'}}, namespace='urn:brocade.com:mgmt:brocade-openflow', defining_module='brocade-openflow', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'rbridge-id', u'openflow']

  def _rest_path(self):
    if hasattr(self, "_parent"):
      if self._rest_name:
        return self._parent._rest_path()+[self._rest_name]
      else:
        return self._parent._rest_path()
    else:
      return [u'rbridge-id', u'openflow']

  def _get_logical_instance(self):
    """
    Getter method for logical_instance, mapped from YANG variable /rbridge_id/openflow/logical_instance (list)

    YANG Description: OpenFlow logical instance configuration. There can be multiple
logical instances under a physical switch.
    """
    return self.__logical_instance
      
  def _set_logical_instance(self, v, load=False):
    """
    Setter method for logical_instance, mapped from YANG variable /rbridge_id/openflow/logical_instance (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_logical_instance is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_logical_instance() directly.

    YANG Description: OpenFlow logical instance configuration. There can be multiple
logical instances under a physical switch.
    """
    try:
      t = YANGDynClass(v,base=YANGListType("instance_id",logical_instance.logical_instance, yang_name="logical-instance", rest_name="logical-instance", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='instance-id', extensions={u'tailf-common': {u'info': u'OpenFlow logical instance configuration', u'callpoint': u'OpenFlowLogicalInstance'}}), is_container='list', yang_name="logical-instance", rest_name="logical-instance", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'OpenFlow logical instance configuration', u'callpoint': u'OpenFlowLogicalInstance'}}, namespace='urn:brocade.com:mgmt:brocade-openflow', defining_module='brocade-openflow', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """logical_instance must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("instance_id",logical_instance.logical_instance, yang_name="logical-instance", rest_name="logical-instance", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='instance-id', extensions={u'tailf-common': {u'info': u'OpenFlow logical instance configuration', u'callpoint': u'OpenFlowLogicalInstance'}}), is_container='list', yang_name="logical-instance", rest_name="logical-instance", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'OpenFlow logical instance configuration', u'callpoint': u'OpenFlowLogicalInstance'}}, namespace='urn:brocade.com:mgmt:brocade-openflow', defining_module='brocade-openflow', yang_type='list', is_config=True)""",
        })

    self.__logical_instance = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_logical_instance(self):
    self.__logical_instance = YANGDynClass(base=YANGListType("instance_id",logical_instance.logical_instance, yang_name="logical-instance", rest_name="logical-instance", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='instance-id', extensions={u'tailf-common': {u'info': u'OpenFlow logical instance configuration', u'callpoint': u'OpenFlowLogicalInstance'}}), is_container='list', yang_name="logical-instance", rest_name="logical-instance", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'OpenFlow logical instance configuration', u'callpoint': u'OpenFlowLogicalInstance'}}, namespace='urn:brocade.com:mgmt:brocade-openflow', defining_module='brocade-openflow', yang_type='list', is_config=True)

  logical_instance = __builtin__.property(_get_logical_instance, _set_logical_instance)


  _pyangbind_elements = {'logical_instance': logical_instance, }


