
from operator import attrgetter
import pyangbind.lib.xpathhelper as xpathhelper
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType, RestrictedClassType, TypedListType
from pyangbind.lib.yangtypes import YANGBool, YANGListType, YANGDynClass, ReferenceType
from pyangbind.lib.base import PybindBase
from decimal import Decimal
from bitarray import bitarray
import __builtin__
class isns_vrf_forwarding_list(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module brocade-isns-ext - based on the path /brocade_isns_ext_rpc/isns-get-vrf-forwarding/output/isns-vrf-forwarding-list. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: This is a list providing the isns esi timeout
and isns loopback ip address.
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_rest_name', '_extmethods', '__isns_vrf_id','__isns_ipaddress','__isns_esi_timeout',)

  _yang_name = 'isns-vrf-forwarding-list'
  _rest_name = 'isns-vrf-forwarding-list'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    path_helper_ = kwargs.pop("path_helper", None)
    if path_helper_ is False:
      self._path_helper = False
    elif path_helper_ is not None and isinstance(path_helper_, xpathhelper.YANGPathHelper):
      self._path_helper = path_helper_
    elif hasattr(self, "_parent"):
      path_helper_ = getattr(self._parent, "_path_helper", False)
      self._path_helper = path_helper_
    else:
      self._path_helper = False

    extmethods = kwargs.pop("extmethods", None)
    if extmethods is False:
      self._extmethods = False
    elif extmethods is not None and isinstance(extmethods, dict):
      self._extmethods = extmethods
    elif hasattr(self, "_parent"):
      extmethods = getattr(self._parent, "_extmethods", None)
      self._extmethods = extmethods
    else:
      self._extmethods = False
    self.__isns_vrf_id = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="isns-vrf-id", rest_name="isns-vrf-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, is_keyval=True, namespace='urn:brocade.com:mgmt:brocade-isns-ext', defining_module='brocade-isns-ext', yang_type='uint32', is_config=True)
    self.__isns_esi_timeout = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="isns-esi-timeout", rest_name="isns-esi-timeout", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, namespace='urn:brocade.com:mgmt:brocade-isns-ext', defining_module='brocade-isns-ext', yang_type='uint32', is_config=True)
    self.__isns_ipaddress = YANGDynClass(base=RestrictedClassType(base_type=unicode, restriction_dict={'pattern': u'(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])(%[\\p{N}\\p{L}]+)?'}), is_leaf=True, yang_name="isns-ipaddress", rest_name="isns-ipaddress", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, namespace='urn:brocade.com:mgmt:brocade-isns-ext', defining_module='brocade-isns-ext', yang_type='inet:ipv4-address', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'brocade_isns_ext_rpc', u'isns-get-vrf-forwarding', u'output', u'isns-vrf-forwarding-list']

  def _rest_path(self):
    if hasattr(self, "_parent"):
      if self._rest_name:
        return self._parent._rest_path()+[self._rest_name]
      else:
        return self._parent._rest_path()
    else:
      return [u'isns-get-vrf-forwarding', u'output', u'isns-vrf-forwarding-list']

  def _get_isns_vrf_id(self):
    """
    Getter method for isns_vrf_id, mapped from YANG variable /brocade_isns_ext_rpc/isns_get_vrf_forwarding/output/isns_vrf_forwarding_list/isns_vrf_id (uint32)

    YANG Description: This leaf indicates the fabric assigned
session MAC address of the End Node.
    """
    return self.__isns_vrf_id
      
  def _set_isns_vrf_id(self, v, load=False):
    """
    Setter method for isns_vrf_id, mapped from YANG variable /brocade_isns_ext_rpc/isns_get_vrf_forwarding/output/isns_vrf_forwarding_list/isns_vrf_id (uint32)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_isns_vrf_id is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_isns_vrf_id() directly.

    YANG Description: This leaf indicates the fabric assigned
session MAC address of the End Node.
    """
    parent = getattr(self, "_parent", None)
    if parent is not None and load is False:
      raise AttributeError("Cannot set keys directly when" +
                             " within an instantiated list")

    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="isns-vrf-id", rest_name="isns-vrf-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, is_keyval=True, namespace='urn:brocade.com:mgmt:brocade-isns-ext', defining_module='brocade-isns-ext', yang_type='uint32', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """isns_vrf_id must be of a type compatible with uint32""",
          'defined-type': "uint32",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="isns-vrf-id", rest_name="isns-vrf-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, is_keyval=True, namespace='urn:brocade.com:mgmt:brocade-isns-ext', defining_module='brocade-isns-ext', yang_type='uint32', is_config=True)""",
        })

    self.__isns_vrf_id = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_isns_vrf_id(self):
    self.__isns_vrf_id = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="isns-vrf-id", rest_name="isns-vrf-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, is_keyval=True, namespace='urn:brocade.com:mgmt:brocade-isns-ext', defining_module='brocade-isns-ext', yang_type='uint32', is_config=True)


  def _get_isns_ipaddress(self):
    """
    Getter method for isns_ipaddress, mapped from YANG variable /brocade_isns_ext_rpc/isns_get_vrf_forwarding/output/isns_vrf_forwarding_list/isns_ipaddress (inet:ipv4-address)

    YANG Description: This leaf indicates the devices ip-address.
    """
    return self.__isns_ipaddress
      
  def _set_isns_ipaddress(self, v, load=False):
    """
    Setter method for isns_ipaddress, mapped from YANG variable /brocade_isns_ext_rpc/isns_get_vrf_forwarding/output/isns_vrf_forwarding_list/isns_ipaddress (inet:ipv4-address)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_isns_ipaddress is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_isns_ipaddress() directly.

    YANG Description: This leaf indicates the devices ip-address.
    """
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=unicode, restriction_dict={'pattern': u'(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])(%[\\p{N}\\p{L}]+)?'}), is_leaf=True, yang_name="isns-ipaddress", rest_name="isns-ipaddress", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, namespace='urn:brocade.com:mgmt:brocade-isns-ext', defining_module='brocade-isns-ext', yang_type='inet:ipv4-address', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """isns_ipaddress must be of a type compatible with inet:ipv4-address""",
          'defined-type': "inet:ipv4-address",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=unicode, restriction_dict={'pattern': u'(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])(%[\\p{N}\\p{L}]+)?'}), is_leaf=True, yang_name="isns-ipaddress", rest_name="isns-ipaddress", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, namespace='urn:brocade.com:mgmt:brocade-isns-ext', defining_module='brocade-isns-ext', yang_type='inet:ipv4-address', is_config=True)""",
        })

    self.__isns_ipaddress = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_isns_ipaddress(self):
    self.__isns_ipaddress = YANGDynClass(base=RestrictedClassType(base_type=unicode, restriction_dict={'pattern': u'(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])(%[\\p{N}\\p{L}]+)?'}), is_leaf=True, yang_name="isns-ipaddress", rest_name="isns-ipaddress", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, namespace='urn:brocade.com:mgmt:brocade-isns-ext', defining_module='brocade-isns-ext', yang_type='inet:ipv4-address', is_config=True)


  def _get_isns_esi_timeout(self):
    """
    Getter method for isns_esi_timeout, mapped from YANG variable /brocade_isns_ext_rpc/isns_get_vrf_forwarding/output/isns_vrf_forwarding_list/isns_esi_timeout (uint32)

    YANG Description: This leaf indicates the devices ip-address.
    """
    return self.__isns_esi_timeout
      
  def _set_isns_esi_timeout(self, v, load=False):
    """
    Setter method for isns_esi_timeout, mapped from YANG variable /brocade_isns_ext_rpc/isns_get_vrf_forwarding/output/isns_vrf_forwarding_list/isns_esi_timeout (uint32)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_isns_esi_timeout is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_isns_esi_timeout() directly.

    YANG Description: This leaf indicates the devices ip-address.
    """
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="isns-esi-timeout", rest_name="isns-esi-timeout", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, namespace='urn:brocade.com:mgmt:brocade-isns-ext', defining_module='brocade-isns-ext', yang_type='uint32', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """isns_esi_timeout must be of a type compatible with uint32""",
          'defined-type': "uint32",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="isns-esi-timeout", rest_name="isns-esi-timeout", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, namespace='urn:brocade.com:mgmt:brocade-isns-ext', defining_module='brocade-isns-ext', yang_type='uint32', is_config=True)""",
        })

    self.__isns_esi_timeout = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_isns_esi_timeout(self):
    self.__isns_esi_timeout = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="isns-esi-timeout", rest_name="isns-esi-timeout", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, namespace='urn:brocade.com:mgmt:brocade-isns-ext', defining_module='brocade-isns-ext', yang_type='uint32', is_config=True)

  isns_vrf_id = __builtin__.property(_get_isns_vrf_id, _set_isns_vrf_id)
  isns_ipaddress = __builtin__.property(_get_isns_ipaddress, _set_isns_ipaddress)
  isns_esi_timeout = __builtin__.property(_get_isns_esi_timeout, _set_isns_esi_timeout)


  _pyangbind_elements = {'isns_vrf_id': isns_vrf_id, 'isns_ipaddress': isns_ipaddress, 'isns_esi_timeout': isns_esi_timeout, }


