
from operator import attrgetter
import pyangbind.lib.xpathhelper as xpathhelper
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType, RestrictedClassType, TypedListType
from pyangbind.lib.yangtypes import YANGBool, YANGListType, YANGDynClass, ReferenceType
from pyangbind.lib.base import PybindBase
from decimal import Decimal
from bitarray import bitarray
import __builtin__
class auto_recovery(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module brocade-mac-address-table - based on the path /mac-address-table/mac-move/auto-recovery. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Auto recovery of port on MAC move
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_rest_name', '_extmethods', '__auto_recovery_enable','__auto_recovery_time',)

  _yang_name = 'auto-recovery'
  _rest_name = 'auto-recovery'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    path_helper_ = kwargs.pop("path_helper", None)
    if path_helper_ is False:
      self._path_helper = False
    elif path_helper_ is not None and isinstance(path_helper_, xpathhelper.YANGPathHelper):
      self._path_helper = path_helper_
    elif hasattr(self, "_parent"):
      path_helper_ = getattr(self._parent, "_path_helper", False)
      self._path_helper = path_helper_
    else:
      self._path_helper = False

    extmethods = kwargs.pop("extmethods", None)
    if extmethods is False:
      self._extmethods = False
    elif extmethods is not None and isinstance(extmethods, dict):
      self._extmethods = extmethods
    elif hasattr(self, "_parent"):
      extmethods = getattr(self._parent, "_extmethods", None)
      self._extmethods = extmethods
    else:
      self._extmethods = False
    self.__auto_recovery_enable = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="auto-recovery-enable", rest_name="enable", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Enable auto recovery', u'alt-name': u'enable'}}, namespace='urn:brocade.com:mgmt:brocade-mac-address-table', defining_module='brocade-mac-address-table', yang_type='empty', is_config=True)
    self.__auto_recovery_time = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': [u'3..30']}), default=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32)(5), is_leaf=True, yang_name="auto-recovery-time", rest_name="time", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Auto recovery time in minutes (default = 5)', u'alt-name': u'time'}}, namespace='urn:brocade.com:mgmt:brocade-mac-address-table', defining_module='brocade-mac-address-table', yang_type='uint32', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'mac-address-table', u'mac-move', u'auto-recovery']

  def _rest_path(self):
    if hasattr(self, "_parent"):
      if self._rest_name:
        return self._parent._rest_path()+[self._rest_name]
      else:
        return self._parent._rest_path()
    else:
      return [u'mac-address-table', u'mac-move', u'auto-recovery']

  def _get_auto_recovery_enable(self):
    """
    Getter method for auto_recovery_enable, mapped from YANG variable /mac_address_table/mac_move/auto_recovery/auto_recovery_enable (empty)

    YANG Description: Enable auto recovery
    """
    return self.__auto_recovery_enable
      
  def _set_auto_recovery_enable(self, v, load=False):
    """
    Setter method for auto_recovery_enable, mapped from YANG variable /mac_address_table/mac_move/auto_recovery/auto_recovery_enable (empty)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_auto_recovery_enable is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_auto_recovery_enable() directly.

    YANG Description: Enable auto recovery
    """
    try:
      t = YANGDynClass(v,base=YANGBool, is_leaf=True, yang_name="auto-recovery-enable", rest_name="enable", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Enable auto recovery', u'alt-name': u'enable'}}, namespace='urn:brocade.com:mgmt:brocade-mac-address-table', defining_module='brocade-mac-address-table', yang_type='empty', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """auto_recovery_enable must be of a type compatible with empty""",
          'defined-type': "empty",
          'generated-type': """YANGDynClass(base=YANGBool, is_leaf=True, yang_name="auto-recovery-enable", rest_name="enable", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Enable auto recovery', u'alt-name': u'enable'}}, namespace='urn:brocade.com:mgmt:brocade-mac-address-table', defining_module='brocade-mac-address-table', yang_type='empty', is_config=True)""",
        })

    self.__auto_recovery_enable = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_auto_recovery_enable(self):
    self.__auto_recovery_enable = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="auto-recovery-enable", rest_name="enable", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Enable auto recovery', u'alt-name': u'enable'}}, namespace='urn:brocade.com:mgmt:brocade-mac-address-table', defining_module='brocade-mac-address-table', yang_type='empty', is_config=True)


  def _get_auto_recovery_time(self):
    """
    Getter method for auto_recovery_time, mapped from YANG variable /mac_address_table/mac_move/auto_recovery/auto_recovery_time (uint32)

    YANG Description: Auto recovery time in minutes (default = 5)
    """
    return self.__auto_recovery_time
      
  def _set_auto_recovery_time(self, v, load=False):
    """
    Setter method for auto_recovery_time, mapped from YANG variable /mac_address_table/mac_move/auto_recovery/auto_recovery_time (uint32)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_auto_recovery_time is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_auto_recovery_time() directly.

    YANG Description: Auto recovery time in minutes (default = 5)
    """
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': [u'3..30']}), default=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32)(5), is_leaf=True, yang_name="auto-recovery-time", rest_name="time", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Auto recovery time in minutes (default = 5)', u'alt-name': u'time'}}, namespace='urn:brocade.com:mgmt:brocade-mac-address-table', defining_module='brocade-mac-address-table', yang_type='uint32', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """auto_recovery_time must be of a type compatible with uint32""",
          'defined-type': "uint32",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': [u'3..30']}), default=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32)(5), is_leaf=True, yang_name="auto-recovery-time", rest_name="time", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Auto recovery time in minutes (default = 5)', u'alt-name': u'time'}}, namespace='urn:brocade.com:mgmt:brocade-mac-address-table', defining_module='brocade-mac-address-table', yang_type='uint32', is_config=True)""",
        })

    self.__auto_recovery_time = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_auto_recovery_time(self):
    self.__auto_recovery_time = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': [u'3..30']}), default=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32)(5), is_leaf=True, yang_name="auto-recovery-time", rest_name="time", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Auto recovery time in minutes (default = 5)', u'alt-name': u'time'}}, namespace='urn:brocade.com:mgmt:brocade-mac-address-table', defining_module='brocade-mac-address-table', yang_type='uint32', is_config=True)

  auto_recovery_enable = __builtin__.property(_get_auto_recovery_enable, _set_auto_recovery_enable)
  auto_recovery_time = __builtin__.property(_get_auto_recovery_time, _set_auto_recovery_time)


  _pyangbind_elements = {'auto_recovery_enable': auto_recovery_enable, 'auto_recovery_time': auto_recovery_time, }


