
from operator import attrgetter
import pyangbind.lib.xpathhelper as xpathhelper
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType, RestrictedClassType, TypedListType
from pyangbind.lib.yangtypes import YANGBool, YANGListType, YANGDynClass, ReferenceType
from pyangbind.lib.base import PybindBase
from decimal import Decimal
from bitarray import bitarray
import __builtin__
import cluster_output
class output(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module brocade-firmware - based on the path /brocade_firmware_rpc/firmware-download/output. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_rest_name', '_extmethods', '__fwdl_cmd_status','__fwdl_cmd_msg','__cluster_output',)

  _yang_name = 'output'
  _rest_name = 'output'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    path_helper_ = kwargs.pop("path_helper", None)
    if path_helper_ is False:
      self._path_helper = False
    elif path_helper_ is not None and isinstance(path_helper_, xpathhelper.YANGPathHelper):
      self._path_helper = path_helper_
    elif hasattr(self, "_parent"):
      path_helper_ = getattr(self._parent, "_path_helper", False)
      self._path_helper = path_helper_
    else:
      self._path_helper = False

    extmethods = kwargs.pop("extmethods", None)
    if extmethods is False:
      self._extmethods = False
    elif extmethods is not None and isinstance(extmethods, dict):
      self._extmethods = extmethods
    elif hasattr(self, "_parent"):
      extmethods = getattr(self._parent, "_extmethods", None)
      self._extmethods = extmethods
    else:
      self._extmethods = False
    self.__cluster_output = YANGDynClass(base=YANGListType(False,cluster_output.cluster_output, yang_name="cluster-output", rest_name="cluster-output", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='False', extensions=None), is_container='list', yang_name="cluster-output", rest_name="cluster-output", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, extensions=None, namespace='urn:brocade.com:mgmt:brocade-firmware', defining_module='brocade-firmware', yang_type='list', is_config=True)
    self.__fwdl_cmd_status = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range': ['-2147483648..2147483647']}, int_size=32), is_leaf=True, yang_name="fwdl-cmd-status", rest_name="fwdl-cmd-status", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, extensions={u'tailf-common': {u'info': u'Status code for the preinstall check. 0 is success, -1 is failure, -2 is invalid rbridge-id'}}, namespace='urn:brocade.com:mgmt:brocade-firmware', defining_module='brocade-firmware', yang_type='int32', is_config=True)
    self.__fwdl_cmd_msg = YANGDynClass(base=unicode, is_leaf=True, yang_name="fwdl-cmd-msg", rest_name="fwdl-cmd-msg", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, extensions={u'tailf-common': {u'info': u'Preinstall error string'}}, namespace='urn:brocade.com:mgmt:brocade-firmware', defining_module='brocade-firmware', yang_type='string', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'brocade_firmware_rpc', u'firmware-download', u'output']

  def _rest_path(self):
    if hasattr(self, "_parent"):
      if self._rest_name:
        return self._parent._rest_path()+[self._rest_name]
      else:
        return self._parent._rest_path()
    else:
      return [u'firmware-download', u'output']

  def _get_fwdl_cmd_status(self):
    """
    Getter method for fwdl_cmd_status, mapped from YANG variable /brocade_firmware_rpc/firmware_download/output/fwdl_cmd_status (int32)
    """
    return self.__fwdl_cmd_status
      
  def _set_fwdl_cmd_status(self, v, load=False):
    """
    Setter method for fwdl_cmd_status, mapped from YANG variable /brocade_firmware_rpc/firmware_download/output/fwdl_cmd_status (int32)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_fwdl_cmd_status is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_fwdl_cmd_status() directly.
    """
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range': ['-2147483648..2147483647']}, int_size=32), is_leaf=True, yang_name="fwdl-cmd-status", rest_name="fwdl-cmd-status", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, extensions={u'tailf-common': {u'info': u'Status code for the preinstall check. 0 is success, -1 is failure, -2 is invalid rbridge-id'}}, namespace='urn:brocade.com:mgmt:brocade-firmware', defining_module='brocade-firmware', yang_type='int32', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """fwdl_cmd_status must be of a type compatible with int32""",
          'defined-type': "int32",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range': ['-2147483648..2147483647']}, int_size=32), is_leaf=True, yang_name="fwdl-cmd-status", rest_name="fwdl-cmd-status", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, extensions={u'tailf-common': {u'info': u'Status code for the preinstall check. 0 is success, -1 is failure, -2 is invalid rbridge-id'}}, namespace='urn:brocade.com:mgmt:brocade-firmware', defining_module='brocade-firmware', yang_type='int32', is_config=True)""",
        })

    self.__fwdl_cmd_status = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_fwdl_cmd_status(self):
    self.__fwdl_cmd_status = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range': ['-2147483648..2147483647']}, int_size=32), is_leaf=True, yang_name="fwdl-cmd-status", rest_name="fwdl-cmd-status", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, extensions={u'tailf-common': {u'info': u'Status code for the preinstall check. 0 is success, -1 is failure, -2 is invalid rbridge-id'}}, namespace='urn:brocade.com:mgmt:brocade-firmware', defining_module='brocade-firmware', yang_type='int32', is_config=True)


  def _get_fwdl_cmd_msg(self):
    """
    Getter method for fwdl_cmd_msg, mapped from YANG variable /brocade_firmware_rpc/firmware_download/output/fwdl_cmd_msg (string)
    """
    return self.__fwdl_cmd_msg
      
  def _set_fwdl_cmd_msg(self, v, load=False):
    """
    Setter method for fwdl_cmd_msg, mapped from YANG variable /brocade_firmware_rpc/firmware_download/output/fwdl_cmd_msg (string)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_fwdl_cmd_msg is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_fwdl_cmd_msg() directly.
    """
    try:
      t = YANGDynClass(v,base=unicode, is_leaf=True, yang_name="fwdl-cmd-msg", rest_name="fwdl-cmd-msg", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, extensions={u'tailf-common': {u'info': u'Preinstall error string'}}, namespace='urn:brocade.com:mgmt:brocade-firmware', defining_module='brocade-firmware', yang_type='string', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """fwdl_cmd_msg must be of a type compatible with string""",
          'defined-type': "string",
          'generated-type': """YANGDynClass(base=unicode, is_leaf=True, yang_name="fwdl-cmd-msg", rest_name="fwdl-cmd-msg", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, extensions={u'tailf-common': {u'info': u'Preinstall error string'}}, namespace='urn:brocade.com:mgmt:brocade-firmware', defining_module='brocade-firmware', yang_type='string', is_config=True)""",
        })

    self.__fwdl_cmd_msg = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_fwdl_cmd_msg(self):
    self.__fwdl_cmd_msg = YANGDynClass(base=unicode, is_leaf=True, yang_name="fwdl-cmd-msg", rest_name="fwdl-cmd-msg", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, extensions={u'tailf-common': {u'info': u'Preinstall error string'}}, namespace='urn:brocade.com:mgmt:brocade-firmware', defining_module='brocade-firmware', yang_type='string', is_config=True)


  def _get_cluster_output(self):
    """
    Getter method for cluster_output, mapped from YANG variable /brocade_firmware_rpc/firmware_download/output/cluster_output (list)
    """
    return self.__cluster_output
      
  def _set_cluster_output(self, v, load=False):
    """
    Setter method for cluster_output, mapped from YANG variable /brocade_firmware_rpc/firmware_download/output/cluster_output (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_cluster_output is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_cluster_output() directly.
    """
    try:
      t = YANGDynClass(v,base=YANGListType(False,cluster_output.cluster_output, yang_name="cluster-output", rest_name="cluster-output", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='False', extensions=None), is_container='list', yang_name="cluster-output", rest_name="cluster-output", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, extensions=None, namespace='urn:brocade.com:mgmt:brocade-firmware', defining_module='brocade-firmware', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """cluster_output must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType(False,cluster_output.cluster_output, yang_name="cluster-output", rest_name="cluster-output", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='False', extensions=None), is_container='list', yang_name="cluster-output", rest_name="cluster-output", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, extensions=None, namespace='urn:brocade.com:mgmt:brocade-firmware', defining_module='brocade-firmware', yang_type='list', is_config=True)""",
        })

    self.__cluster_output = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_cluster_output(self):
    self.__cluster_output = YANGDynClass(base=YANGListType(False,cluster_output.cluster_output, yang_name="cluster-output", rest_name="cluster-output", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='False', extensions=None), is_container='list', yang_name="cluster-output", rest_name="cluster-output", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, extensions=None, namespace='urn:brocade.com:mgmt:brocade-firmware', defining_module='brocade-firmware', yang_type='list', is_config=True)

  fwdl_cmd_status = __builtin__.property(_get_fwdl_cmd_status, _set_fwdl_cmd_status)
  fwdl_cmd_msg = __builtin__.property(_get_fwdl_cmd_msg, _set_fwdl_cmd_msg)
  cluster_output = __builtin__.property(_get_cluster_output, _set_cluster_output)


  _pyangbind_elements = {'fwdl_cmd_status': fwdl_cmd_status, 'fwdl_cmd_msg': fwdl_cmd_msg, 'cluster_output': cluster_output, }


