
from operator import attrgetter
import pyangbind.lib.xpathhelper as xpathhelper
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType, RestrictedClassType, TypedListType
from pyangbind.lib.yangtypes import YANGBool, YANGListType, YANGDynClass, ReferenceType
from pyangbind.lib.base import PybindBase
from decimal import Decimal
from bitarray import bitarray
import __builtin__
class mpls_ldp_session_one(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module brocade-mpls - based on the path /brocade_mpls_rpc/get-mpls-ldp-session-one/input/mpls-ldp-session-one. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_rest_name', '_extmethods', '__ldpid','__labelspaceId','__debug','__out','__in_',)

  _yang_name = 'mpls-ldp-session-one'
  _rest_name = 'mpls-ldp-session-one'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    path_helper_ = kwargs.pop("path_helper", None)
    if path_helper_ is False:
      self._path_helper = False
    elif path_helper_ is not None and isinstance(path_helper_, xpathhelper.YANGPathHelper):
      self._path_helper = path_helper_
    elif hasattr(self, "_parent"):
      path_helper_ = getattr(self._parent, "_path_helper", False)
      self._path_helper = path_helper_
    else:
      self._path_helper = False

    extmethods = kwargs.pop("extmethods", None)
    if extmethods is False:
      self._extmethods = False
    elif extmethods is not None and isinstance(extmethods, dict):
      self._extmethods = extmethods
    elif hasattr(self, "_parent"):
      extmethods = getattr(self._parent, "_extmethods", None)
      self._extmethods = extmethods
    else:
      self._extmethods = False
    self.__debug = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="debug", rest_name="debug", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, namespace='urn:brocade.com:mgmt:brocade-mpls', defining_module='brocade-mpls', yang_type='boolean', is_config=True)
    self.__ldpid = YANGDynClass(base=RestrictedClassType(base_type=unicode, restriction_dict={'pattern': u'(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])(%[\\p{N}\\p{L}]+)?'}), is_leaf=True, yang_name="ldpid", rest_name="ldpid", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, namespace='urn:brocade.com:mgmt:brocade-mpls', defining_module='brocade-mpls', yang_type='inet:ipv4-address', is_config=True)
    self.__labelspaceId = YANGDynClass(base=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..255']}, int_size=8), is_leaf=True, yang_name="labelspaceId", rest_name="labelspaceId", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, namespace='urn:brocade.com:mgmt:brocade-mpls', defining_module='brocade-mpls', yang_type='uint8', is_config=True)
    self.__in_ = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="in", rest_name="in", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, namespace='urn:brocade.com:mgmt:brocade-mpls', defining_module='brocade-mpls', yang_type='boolean', is_config=True)
    self.__out = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="out", rest_name="out", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, namespace='urn:brocade.com:mgmt:brocade-mpls', defining_module='brocade-mpls', yang_type='boolean', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'brocade_mpls_rpc', u'get-mpls-ldp-session-one', u'input', u'mpls-ldp-session-one']

  def _rest_path(self):
    if hasattr(self, "_parent"):
      if self._rest_name:
        return self._parent._rest_path()+[self._rest_name]
      else:
        return self._parent._rest_path()
    else:
      return [u'get-mpls-ldp-session-one', u'input', u'mpls-ldp-session-one']

  def _get_ldpid(self):
    """
    Getter method for ldpid, mapped from YANG variable /brocade_mpls_rpc/get_mpls_ldp_session_one/input/mpls_ldp_session_one/ldpid (inet:ipv4-address)

    YANG Description: Neighbor LDP ID
    """
    return self.__ldpid
      
  def _set_ldpid(self, v, load=False):
    """
    Setter method for ldpid, mapped from YANG variable /brocade_mpls_rpc/get_mpls_ldp_session_one/input/mpls_ldp_session_one/ldpid (inet:ipv4-address)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_ldpid is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_ldpid() directly.

    YANG Description: Neighbor LDP ID
    """
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=unicode, restriction_dict={'pattern': u'(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])(%[\\p{N}\\p{L}]+)?'}), is_leaf=True, yang_name="ldpid", rest_name="ldpid", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, namespace='urn:brocade.com:mgmt:brocade-mpls', defining_module='brocade-mpls', yang_type='inet:ipv4-address', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """ldpid must be of a type compatible with inet:ipv4-address""",
          'defined-type': "inet:ipv4-address",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=unicode, restriction_dict={'pattern': u'(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])(%[\\p{N}\\p{L}]+)?'}), is_leaf=True, yang_name="ldpid", rest_name="ldpid", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, namespace='urn:brocade.com:mgmt:brocade-mpls', defining_module='brocade-mpls', yang_type='inet:ipv4-address', is_config=True)""",
        })

    self.__ldpid = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_ldpid(self):
    self.__ldpid = YANGDynClass(base=RestrictedClassType(base_type=unicode, restriction_dict={'pattern': u'(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])(%[\\p{N}\\p{L}]+)?'}), is_leaf=True, yang_name="ldpid", rest_name="ldpid", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, namespace='urn:brocade.com:mgmt:brocade-mpls', defining_module='brocade-mpls', yang_type='inet:ipv4-address', is_config=True)


  def _get_labelspaceId(self):
    """
    Getter method for labelspaceId, mapped from YANG variable /brocade_mpls_rpc/get_mpls_ldp_session_one/input/mpls_ldp_session_one/labelspaceId (uint8)

    YANG Description: Neighbor Labelspace ID
    """
    return self.__labelspaceId
      
  def _set_labelspaceId(self, v, load=False):
    """
    Setter method for labelspaceId, mapped from YANG variable /brocade_mpls_rpc/get_mpls_ldp_session_one/input/mpls_ldp_session_one/labelspaceId (uint8)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_labelspaceId is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_labelspaceId() directly.

    YANG Description: Neighbor Labelspace ID
    """
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..255']}, int_size=8), is_leaf=True, yang_name="labelspaceId", rest_name="labelspaceId", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, namespace='urn:brocade.com:mgmt:brocade-mpls', defining_module='brocade-mpls', yang_type='uint8', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """labelspaceId must be of a type compatible with uint8""",
          'defined-type': "uint8",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..255']}, int_size=8), is_leaf=True, yang_name="labelspaceId", rest_name="labelspaceId", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, namespace='urn:brocade.com:mgmt:brocade-mpls', defining_module='brocade-mpls', yang_type='uint8', is_config=True)""",
        })

    self.__labelspaceId = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_labelspaceId(self):
    self.__labelspaceId = YANGDynClass(base=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..255']}, int_size=8), is_leaf=True, yang_name="labelspaceId", rest_name="labelspaceId", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, namespace='urn:brocade.com:mgmt:brocade-mpls', defining_module='brocade-mpls', yang_type='uint8', is_config=True)


  def _get_debug(self):
    """
    Getter method for debug, mapped from YANG variable /brocade_mpls_rpc/get_mpls_ldp_session_one/input/mpls_ldp_session_one/debug (boolean)

    YANG Description: debug output
    """
    return self.__debug
      
  def _set_debug(self, v, load=False):
    """
    Setter method for debug, mapped from YANG variable /brocade_mpls_rpc/get_mpls_ldp_session_one/input/mpls_ldp_session_one/debug (boolean)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_debug is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_debug() directly.

    YANG Description: debug output
    """
    try:
      t = YANGDynClass(v,base=YANGBool, is_leaf=True, yang_name="debug", rest_name="debug", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, namespace='urn:brocade.com:mgmt:brocade-mpls', defining_module='brocade-mpls', yang_type='boolean', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """debug must be of a type compatible with boolean""",
          'defined-type': "boolean",
          'generated-type': """YANGDynClass(base=YANGBool, is_leaf=True, yang_name="debug", rest_name="debug", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, namespace='urn:brocade.com:mgmt:brocade-mpls', defining_module='brocade-mpls', yang_type='boolean', is_config=True)""",
        })

    self.__debug = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_debug(self):
    self.__debug = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="debug", rest_name="debug", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, namespace='urn:brocade.com:mgmt:brocade-mpls', defining_module='brocade-mpls', yang_type='boolean', is_config=True)


  def _get_out(self):
    """
    Getter method for out, mapped from YANG variable /brocade_mpls_rpc/get_mpls_ldp_session_one/input/mpls_ldp_session_one/out (boolean)

    YANG Description: Display filtered outbound FECs
    """
    return self.__out
      
  def _set_out(self, v, load=False):
    """
    Setter method for out, mapped from YANG variable /brocade_mpls_rpc/get_mpls_ldp_session_one/input/mpls_ldp_session_one/out (boolean)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_out is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_out() directly.

    YANG Description: Display filtered outbound FECs
    """
    try:
      t = YANGDynClass(v,base=YANGBool, is_leaf=True, yang_name="out", rest_name="out", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, namespace='urn:brocade.com:mgmt:brocade-mpls', defining_module='brocade-mpls', yang_type='boolean', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """out must be of a type compatible with boolean""",
          'defined-type': "boolean",
          'generated-type': """YANGDynClass(base=YANGBool, is_leaf=True, yang_name="out", rest_name="out", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, namespace='urn:brocade.com:mgmt:brocade-mpls', defining_module='brocade-mpls', yang_type='boolean', is_config=True)""",
        })

    self.__out = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_out(self):
    self.__out = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="out", rest_name="out", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, namespace='urn:brocade.com:mgmt:brocade-mpls', defining_module='brocade-mpls', yang_type='boolean', is_config=True)


  def _get_in_(self):
    """
    Getter method for in_, mapped from YANG variable /brocade_mpls_rpc/get_mpls_ldp_session_one/input/mpls_ldp_session_one/in (boolean)

    YANG Description: Display filtered inbound FECs
    """
    return self.__in_
      
  def _set_in_(self, v, load=False):
    """
    Setter method for in_, mapped from YANG variable /brocade_mpls_rpc/get_mpls_ldp_session_one/input/mpls_ldp_session_one/in (boolean)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_in_ is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_in_() directly.

    YANG Description: Display filtered inbound FECs
    """
    try:
      t = YANGDynClass(v,base=YANGBool, is_leaf=True, yang_name="in", rest_name="in", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, namespace='urn:brocade.com:mgmt:brocade-mpls', defining_module='brocade-mpls', yang_type='boolean', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """in_ must be of a type compatible with boolean""",
          'defined-type': "boolean",
          'generated-type': """YANGDynClass(base=YANGBool, is_leaf=True, yang_name="in", rest_name="in", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, namespace='urn:brocade.com:mgmt:brocade-mpls', defining_module='brocade-mpls', yang_type='boolean', is_config=True)""",
        })

    self.__in_ = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_in_(self):
    self.__in_ = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="in", rest_name="in", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=False, namespace='urn:brocade.com:mgmt:brocade-mpls', defining_module='brocade-mpls', yang_type='boolean', is_config=True)

  ldpid = __builtin__.property(_get_ldpid, _set_ldpid)
  labelspaceId = __builtin__.property(_get_labelspaceId, _set_labelspaceId)
  debug = __builtin__.property(_get_debug, _set_debug)
  out = __builtin__.property(_get_out, _set_out)
  in_ = __builtin__.property(_get_in_, _set_in_)


  _pyangbind_elements = {'ldpid': ldpid, 'labelspaceId': labelspaceId, 'debug': debug, 'out': out, 'in_': in_, }


