
from operator import attrgetter
import pyangbind.lib.xpathhelper as xpathhelper
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType, RestrictedClassType, TypedListType
from pyangbind.lib.yangtypes import YANGBool, YANGListType, YANGDynClass, ReferenceType
from pyangbind.lib.base import PybindBase
from decimal import Decimal
from bitarray import bitarray
import __builtin__
import cfm_detail
import cfm_connectivity
class cfm_state(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module brocade-dot1ag-operational - based on the path /cfm-state. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: CFM Operational Information
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_rest_name', '_extmethods', '__cfm_detail','__cfm_connectivity',)

  _yang_name = 'cfm-state'
  _rest_name = 'cfm-state'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    path_helper_ = kwargs.pop("path_helper", None)
    if path_helper_ is False:
      self._path_helper = False
    elif path_helper_ is not None and isinstance(path_helper_, xpathhelper.YANGPathHelper):
      self._path_helper = path_helper_
    elif hasattr(self, "_parent"):
      path_helper_ = getattr(self._parent, "_path_helper", False)
      self._path_helper = path_helper_
    else:
      self._path_helper = False

    extmethods = kwargs.pop("extmethods", None)
    if extmethods is False:
      self._extmethods = False
    elif extmethods is not None and isinstance(extmethods, dict):
      self._extmethods = extmethods
    elif hasattr(self, "_parent"):
      extmethods = getattr(self._parent, "_extmethods", None)
      self._extmethods = extmethods
    else:
      self._extmethods = False
    self.__cfm_connectivity = YANGDynClass(base=cfm_connectivity.cfm_connectivity, is_container='container', yang_name="cfm-connectivity", rest_name="cfm-connectivity", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'callpoint': u'dot1ag-cfm-connectivity', u'cli-suppress-show-path': None}}, namespace='urn:brocade.com:mgmt:brocade-dot1ag-operational', defining_module='brocade-dot1ag-operational', yang_type='container', is_config=False)
    self.__cfm_detail = YANGDynClass(base=cfm_detail.cfm_detail, is_container='container', yang_name="cfm-detail", rest_name="cfm-detail", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'callpoint': u'dot1ag-cfm-detail', u'cli-suppress-show-path': None}}, namespace='urn:brocade.com:mgmt:brocade-dot1ag-operational', defining_module='brocade-dot1ag-operational', yang_type='container', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'cfm-state']

  def _rest_path(self):
    if hasattr(self, "_parent"):
      if self._rest_name:
        return self._parent._rest_path()+[self._rest_name]
      else:
        return self._parent._rest_path()
    else:
      return [u'cfm-state']

  def _get_cfm_detail(self):
    """
    Getter method for cfm_detail, mapped from YANG variable /cfm_state/cfm_detail (container)

    YANG Description: CFM Details
    """
    return self.__cfm_detail
      
  def _set_cfm_detail(self, v, load=False):
    """
    Setter method for cfm_detail, mapped from YANG variable /cfm_state/cfm_detail (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_cfm_detail is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_cfm_detail() directly.

    YANG Description: CFM Details
    """
    try:
      t = YANGDynClass(v,base=cfm_detail.cfm_detail, is_container='container', yang_name="cfm-detail", rest_name="cfm-detail", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'callpoint': u'dot1ag-cfm-detail', u'cli-suppress-show-path': None}}, namespace='urn:brocade.com:mgmt:brocade-dot1ag-operational', defining_module='brocade-dot1ag-operational', yang_type='container', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """cfm_detail must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=cfm_detail.cfm_detail, is_container='container', yang_name="cfm-detail", rest_name="cfm-detail", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'callpoint': u'dot1ag-cfm-detail', u'cli-suppress-show-path': None}}, namespace='urn:brocade.com:mgmt:brocade-dot1ag-operational', defining_module='brocade-dot1ag-operational', yang_type='container', is_config=False)""",
        })

    self.__cfm_detail = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_cfm_detail(self):
    self.__cfm_detail = YANGDynClass(base=cfm_detail.cfm_detail, is_container='container', yang_name="cfm-detail", rest_name="cfm-detail", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'callpoint': u'dot1ag-cfm-detail', u'cli-suppress-show-path': None}}, namespace='urn:brocade.com:mgmt:brocade-dot1ag-operational', defining_module='brocade-dot1ag-operational', yang_type='container', is_config=False)


  def _get_cfm_connectivity(self):
    """
    Getter method for cfm_connectivity, mapped from YANG variable /cfm_state/cfm_connectivity (container)

    YANG Description: CFM Connectivity Details
    """
    return self.__cfm_connectivity
      
  def _set_cfm_connectivity(self, v, load=False):
    """
    Setter method for cfm_connectivity, mapped from YANG variable /cfm_state/cfm_connectivity (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_cfm_connectivity is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_cfm_connectivity() directly.

    YANG Description: CFM Connectivity Details
    """
    try:
      t = YANGDynClass(v,base=cfm_connectivity.cfm_connectivity, is_container='container', yang_name="cfm-connectivity", rest_name="cfm-connectivity", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'callpoint': u'dot1ag-cfm-connectivity', u'cli-suppress-show-path': None}}, namespace='urn:brocade.com:mgmt:brocade-dot1ag-operational', defining_module='brocade-dot1ag-operational', yang_type='container', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """cfm_connectivity must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=cfm_connectivity.cfm_connectivity, is_container='container', yang_name="cfm-connectivity", rest_name="cfm-connectivity", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'callpoint': u'dot1ag-cfm-connectivity', u'cli-suppress-show-path': None}}, namespace='urn:brocade.com:mgmt:brocade-dot1ag-operational', defining_module='brocade-dot1ag-operational', yang_type='container', is_config=False)""",
        })

    self.__cfm_connectivity = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_cfm_connectivity(self):
    self.__cfm_connectivity = YANGDynClass(base=cfm_connectivity.cfm_connectivity, is_container='container', yang_name="cfm-connectivity", rest_name="cfm-connectivity", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'callpoint': u'dot1ag-cfm-connectivity', u'cli-suppress-show-path': None}}, namespace='urn:brocade.com:mgmt:brocade-dot1ag-operational', defining_module='brocade-dot1ag-operational', yang_type='container', is_config=False)

  cfm_detail = __builtin__.property(_get_cfm_detail)
  cfm_connectivity = __builtin__.property(_get_cfm_connectivity)


  _pyangbind_elements = {'cfm_detail': cfm_detail, 'cfm_connectivity': cfm_connectivity, }


