
from operator import attrgetter
import pyangbind.lib.xpathhelper as xpathhelper
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType, RestrictedClassType, TypedListType
from pyangbind.lib.yangtypes import YANGBool, YANGListType, YANGDynClass, ReferenceType
from pyangbind.lib.base import PybindBase
from decimal import Decimal
from bitarray import bitarray
import __builtin__
import subnet_rate_limit
class ipv6(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module brocade-control-plane - based on the path /control-plane/ipv6. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_rest_name', '_extmethods', '__subnet_rate_limit',)

  _yang_name = 'ipv6'
  _rest_name = 'ipv6'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    path_helper_ = kwargs.pop("path_helper", None)
    if path_helper_ is False:
      self._path_helper = False
    elif path_helper_ is not None and isinstance(path_helper_, xpathhelper.YANGPathHelper):
      self._path_helper = path_helper_
    elif hasattr(self, "_parent"):
      path_helper_ = getattr(self._parent, "_path_helper", False)
      self._path_helper = path_helper_
    else:
      self._path_helper = False

    extmethods = kwargs.pop("extmethods", None)
    if extmethods is False:
      self._extmethods = False
    elif extmethods is not None and isinstance(extmethods, dict):
      self._extmethods = extmethods
    elif hasattr(self, "_parent"):
      extmethods = getattr(self._parent, "_extmethods", None)
      self._extmethods = extmethods
    else:
      self._extmethods = False
    self.__subnet_rate_limit = YANGDynClass(base=subnet_rate_limit.subnet_rate_limit, is_container='container', yang_name="subnet-rate-limit", rest_name="subnet-rate-limit", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Rate Limit packets for a subnet', u'cli-sequence-commands': None}}, namespace='urn:brocade.com:mgmt:brocade-control-plane', defining_module='brocade-control-plane', yang_type='container', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'control-plane', u'ipv6']

  def _rest_path(self):
    if hasattr(self, "_parent"):
      if self._rest_name:
        return self._parent._rest_path()+[self._rest_name]
      else:
        return self._parent._rest_path()
    else:
      return [u'control-plane', u'ipv6']

  def _get_subnet_rate_limit(self):
    """
    Getter method for subnet_rate_limit, mapped from YANG variable /control_plane/ipv6/subnet_rate_limit (container)
    """
    return self.__subnet_rate_limit
      
  def _set_subnet_rate_limit(self, v, load=False):
    """
    Setter method for subnet_rate_limit, mapped from YANG variable /control_plane/ipv6/subnet_rate_limit (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_subnet_rate_limit is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_subnet_rate_limit() directly.
    """
    try:
      t = YANGDynClass(v,base=subnet_rate_limit.subnet_rate_limit, is_container='container', yang_name="subnet-rate-limit", rest_name="subnet-rate-limit", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Rate Limit packets for a subnet', u'cli-sequence-commands': None}}, namespace='urn:brocade.com:mgmt:brocade-control-plane', defining_module='brocade-control-plane', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """subnet_rate_limit must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=subnet_rate_limit.subnet_rate_limit, is_container='container', yang_name="subnet-rate-limit", rest_name="subnet-rate-limit", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Rate Limit packets for a subnet', u'cli-sequence-commands': None}}, namespace='urn:brocade.com:mgmt:brocade-control-plane', defining_module='brocade-control-plane', yang_type='container', is_config=True)""",
        })

    self.__subnet_rate_limit = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_subnet_rate_limit(self):
    self.__subnet_rate_limit = YANGDynClass(base=subnet_rate_limit.subnet_rate_limit, is_container='container', yang_name="subnet-rate-limit", rest_name="subnet-rate-limit", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Rate Limit packets for a subnet', u'cli-sequence-commands': None}}, namespace='urn:brocade.com:mgmt:brocade-control-plane', defining_module='brocade-control-plane', yang_type='container', is_config=True)

  subnet_rate_limit = __builtin__.property(_get_subnet_rate_limit, _set_subnet_rate_limit)


  _pyangbind_elements = {'subnet_rate_limit': subnet_rate_limit, }


