
from operator import attrgetter
import pyangbind.lib.xpathhelper as xpathhelper
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType, RestrictedClassType, TypedListType
from pyangbind.lib.yangtypes import YANGBool, YANGListType, YANGDynClass, ReferenceType
from pyangbind.lib.base import PybindBase
from decimal import Decimal
from bitarray import bitarray
import __builtin__
import process_restart
class ha(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module brocade-ha - based on the path /ha. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration related to high availability functionalities.
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_rest_name', '_extmethods', '__process_restart',)

  _yang_name = 'ha'
  _rest_name = 'ha'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    path_helper_ = kwargs.pop("path_helper", None)
    if path_helper_ is False:
      self._path_helper = False
    elif path_helper_ is not None and isinstance(path_helper_, xpathhelper.YANGPathHelper):
      self._path_helper = path_helper_
    elif hasattr(self, "_parent"):
      path_helper_ = getattr(self._parent, "_path_helper", False)
      self._path_helper = path_helper_
    else:
      self._path_helper = False

    extmethods = kwargs.pop("extmethods", None)
    if extmethods is False:
      self._extmethods = False
    elif extmethods is not None and isinstance(extmethods, dict):
      self._extmethods = extmethods
    elif hasattr(self, "_parent"):
      extmethods = getattr(self._parent, "_extmethods", None)
      self._extmethods = extmethods
    else:
      self._extmethods = False
    self.__process_restart = YANGDynClass(base=process_restart.process_restart, is_container='container', yang_name="process-restart", rest_name="process-restart", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure the process restart behaviors', u'display-when': u'((/local-node/swbd-number = "2000") or (/local-node/swbd-number = "2001") or (/local-node/swbd-number = "2002") or (/local-node/swbd-number = "2003"))', u'callpoint': u'ha_callpoint'}}, namespace='urn:brocade.com:mgmt:brocade-ha', defining_module='brocade-ha', yang_type='container', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'ha']

  def _rest_path(self):
    if hasattr(self, "_parent"):
      if self._rest_name:
        return self._parent._rest_path()+[self._rest_name]
      else:
        return self._parent._rest_path()
    else:
      return [u'ha']

  def _get_process_restart(self):
    """
    Getter method for process_restart, mapped from YANG variable /ha/process_restart (container)
    """
    return self.__process_restart
      
  def _set_process_restart(self, v, load=False):
    """
    Setter method for process_restart, mapped from YANG variable /ha/process_restart (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_process_restart is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_process_restart() directly.
    """
    try:
      t = YANGDynClass(v,base=process_restart.process_restart, is_container='container', yang_name="process-restart", rest_name="process-restart", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure the process restart behaviors', u'display-when': u'((/local-node/swbd-number = "2000") or (/local-node/swbd-number = "2001") or (/local-node/swbd-number = "2002") or (/local-node/swbd-number = "2003"))', u'callpoint': u'ha_callpoint'}}, namespace='urn:brocade.com:mgmt:brocade-ha', defining_module='brocade-ha', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """process_restart must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=process_restart.process_restart, is_container='container', yang_name="process-restart", rest_name="process-restart", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure the process restart behaviors', u'display-when': u'((/local-node/swbd-number = "2000") or (/local-node/swbd-number = "2001") or (/local-node/swbd-number = "2002") or (/local-node/swbd-number = "2003"))', u'callpoint': u'ha_callpoint'}}, namespace='urn:brocade.com:mgmt:brocade-ha', defining_module='brocade-ha', yang_type='container', is_config=True)""",
        })

    self.__process_restart = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_process_restart(self):
    self.__process_restart = YANGDynClass(base=process_restart.process_restart, is_container='container', yang_name="process-restart", rest_name="process-restart", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure the process restart behaviors', u'display-when': u'((/local-node/swbd-number = "2000") or (/local-node/swbd-number = "2001") or (/local-node/swbd-number = "2002") or (/local-node/swbd-number = "2003"))', u'callpoint': u'ha_callpoint'}}, namespace='urn:brocade.com:mgmt:brocade-ha', defining_module='brocade-ha', yang_type='container', is_config=True)

  process_restart = __builtin__.property(_get_process_restart, _set_process_restart)


  _pyangbind_elements = {'process_restart': process_restart, }


