
from operator import attrgetter
import pyangbind.lib.xpathhelper as xpathhelper
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType, RestrictedClassType, TypedListType
from pyangbind.lib.yangtypes import YANGBool, YANGListType, YANGDynClass, ReferenceType
from pyangbind.lib.base import PybindBase
from decimal import Decimal
from bitarray import bitarray
import __builtin__
class enableInterfaceLevel(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module brocade-interface - based on the path /interface/ethernet/openflow/enableInterfaceLevel. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_rest_name', '_extmethods', '__modeType','__hybrid_mode',)

  _yang_name = 'enableInterfaceLevel'
  _rest_name = 'enable'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    path_helper_ = kwargs.pop("path_helper", None)
    if path_helper_ is False:
      self._path_helper = False
    elif path_helper_ is not None and isinstance(path_helper_, xpathhelper.YANGPathHelper):
      self._path_helper = path_helper_
    elif hasattr(self, "_parent"):
      path_helper_ = getattr(self._parent, "_path_helper", False)
      self._path_helper = path_helper_
    else:
      self._path_helper = False

    extmethods = kwargs.pop("extmethods", None)
    if extmethods is False:
      self._extmethods = False
    elif extmethods is not None and isinstance(extmethods, dict):
      self._extmethods = extmethods
    elif hasattr(self, "_parent"):
      extmethods = getattr(self._parent, "_extmethods", None)
      self._extmethods = extmethods
    else:
      self._extmethods = False
    self.__modeType = YANGDynClass(base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'layer3': {'value': 2}, u'layer2': {'value': 1}, u'layer23': {'value': 3}},), is_leaf=True, yang_name="modeType", rest_name="", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Enable OF Version', u'cli-drop-node-name': None}}, namespace='urn:brocade.com:mgmt:brocade-openflow', defining_module='brocade-openflow', yang_type='enumeration', is_config=True)
    self.__hybrid_mode = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="hybrid-mode", rest_name="hybrid-mode", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Hybrid-mode'}}, namespace='urn:brocade.com:mgmt:brocade-openflow', defining_module='brocade-openflow', yang_type='empty', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'interface', u'ethernet', u'openflow', u'enableInterfaceLevel']

  def _rest_path(self):
    if hasattr(self, "_parent"):
      if self._rest_name:
        return self._parent._rest_path()+[self._rest_name]
      else:
        return self._parent._rest_path()
    else:
      return [u'interface', u'Ethernet', u'openflow', u'enable']

  def _get_modeType(self):
    """
    Getter method for modeType, mapped from YANG variable /interface/ethernet/openflow/enableInterfaceLevel/modeType (enumeration)
    """
    return self.__modeType
      
  def _set_modeType(self, v, load=False):
    """
    Setter method for modeType, mapped from YANG variable /interface/ethernet/openflow/enableInterfaceLevel/modeType (enumeration)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_modeType is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_modeType() directly.
    """
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'layer3': {'value': 2}, u'layer2': {'value': 1}, u'layer23': {'value': 3}},), is_leaf=True, yang_name="modeType", rest_name="", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Enable OF Version', u'cli-drop-node-name': None}}, namespace='urn:brocade.com:mgmt:brocade-openflow', defining_module='brocade-openflow', yang_type='enumeration', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """modeType must be of a type compatible with enumeration""",
          'defined-type': "brocade-openflow:enumeration",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'layer3': {'value': 2}, u'layer2': {'value': 1}, u'layer23': {'value': 3}},), is_leaf=True, yang_name="modeType", rest_name="", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Enable OF Version', u'cli-drop-node-name': None}}, namespace='urn:brocade.com:mgmt:brocade-openflow', defining_module='brocade-openflow', yang_type='enumeration', is_config=True)""",
        })

    self.__modeType = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_modeType(self):
    self.__modeType = YANGDynClass(base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'layer3': {'value': 2}, u'layer2': {'value': 1}, u'layer23': {'value': 3}},), is_leaf=True, yang_name="modeType", rest_name="", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Enable OF Version', u'cli-drop-node-name': None}}, namespace='urn:brocade.com:mgmt:brocade-openflow', defining_module='brocade-openflow', yang_type='enumeration', is_config=True)


  def _get_hybrid_mode(self):
    """
    Getter method for hybrid_mode, mapped from YANG variable /interface/ethernet/openflow/enableInterfaceLevel/hybrid_mode (empty)
    """
    return self.__hybrid_mode
      
  def _set_hybrid_mode(self, v, load=False):
    """
    Setter method for hybrid_mode, mapped from YANG variable /interface/ethernet/openflow/enableInterfaceLevel/hybrid_mode (empty)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_hybrid_mode is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_hybrid_mode() directly.
    """
    try:
      t = YANGDynClass(v,base=YANGBool, is_leaf=True, yang_name="hybrid-mode", rest_name="hybrid-mode", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Hybrid-mode'}}, namespace='urn:brocade.com:mgmt:brocade-openflow', defining_module='brocade-openflow', yang_type='empty', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """hybrid_mode must be of a type compatible with empty""",
          'defined-type': "empty",
          'generated-type': """YANGDynClass(base=YANGBool, is_leaf=True, yang_name="hybrid-mode", rest_name="hybrid-mode", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Hybrid-mode'}}, namespace='urn:brocade.com:mgmt:brocade-openflow', defining_module='brocade-openflow', yang_type='empty', is_config=True)""",
        })

    self.__hybrid_mode = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_hybrid_mode(self):
    self.__hybrid_mode = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="hybrid-mode", rest_name="hybrid-mode", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Hybrid-mode'}}, namespace='urn:brocade.com:mgmt:brocade-openflow', defining_module='brocade-openflow', yang_type='empty', is_config=True)

  modeType = __builtin__.property(_get_modeType, _set_modeType)
  hybrid_mode = __builtin__.property(_get_hybrid_mode, _set_hybrid_mode)


  _pyangbind_elements = {'modeType': modeType, 'hybrid_mode': hybrid_mode, }


