
from operator import attrgetter
import pyangbind.lib.xpathhelper as xpathhelper
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType, RestrictedClassType, TypedListType
from pyangbind.lib.yangtypes import YANGBool, YANGListType, YANGDynClass, ReferenceType
from pyangbind.lib.base import PybindBase
from decimal import Decimal
from bitarray import bitarray
import __builtin__
import mldPIM
import mldVlan
class ipv6(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module brocade-interface - based on the path /interface-vlan/vlan/ipv6. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: The IP configurations for an interface.
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_rest_name', '_extmethods', '__mldPIM','__mldVlan',)

  _yang_name = 'ipv6'
  _rest_name = 'ipv6'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    path_helper_ = kwargs.pop("path_helper", None)
    if path_helper_ is False:
      self._path_helper = False
    elif path_helper_ is not None and isinstance(path_helper_, xpathhelper.YANGPathHelper):
      self._path_helper = path_helper_
    elif hasattr(self, "_parent"):
      path_helper_ = getattr(self._parent, "_path_helper", False)
      self._path_helper = path_helper_
    else:
      self._path_helper = False

    extmethods = kwargs.pop("extmethods", None)
    if extmethods is False:
      self._extmethods = False
    elif extmethods is not None and isinstance(extmethods, dict):
      self._extmethods = extmethods
    elif hasattr(self, "_parent"):
      extmethods = getattr(self._parent, "_extmethods", None)
      self._extmethods = extmethods
    else:
      self._extmethods = False
    self.__mldVlan = YANGDynClass(base=mldVlan.mldVlan, is_container='container', yang_name="mldVlan", rest_name="mld", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Multicast Listener Discovery (MLD) Snooping', u'hidden': u'full', u'callpoint': u'MldsVlan', u'cli-incomplete-no': None, u'alt-name': u'mld'}}, namespace='urn:brocade.com:mgmt:brocade-mld-snooping', defining_module='brocade-mld-snooping', yang_type='container', is_config=True)
    self.__mldPIM = YANGDynClass(base=mldPIM.mldPIM, is_container='container', yang_name="mldPIM", rest_name="pim", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'MLD : IpV6 PIM Snooping', u'hidden': u'full', u'callpoint': u'MldsVlan', u'cli-incomplete-no': None, u'alt-name': u'pim'}}, namespace='urn:brocade.com:mgmt:brocade-mld-snooping', defining_module='brocade-mld-snooping', yang_type='container', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'interface-vlan', u'vlan', u'ipv6']

  def _rest_path(self):
    if hasattr(self, "_parent"):
      if self._rest_name:
        return self._parent._rest_path()+[self._rest_name]
      else:
        return self._parent._rest_path()
    else:
      return [u'vlan', u'ipv6']

  def _get_mldPIM(self):
    """
    Getter method for mldPIM, mapped from YANG variable /interface_vlan/vlan/ipv6/mldPIM (container)
    """
    return self.__mldPIM
      
  def _set_mldPIM(self, v, load=False):
    """
    Setter method for mldPIM, mapped from YANG variable /interface_vlan/vlan/ipv6/mldPIM (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_mldPIM is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_mldPIM() directly.
    """
    try:
      t = YANGDynClass(v,base=mldPIM.mldPIM, is_container='container', yang_name="mldPIM", rest_name="pim", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'MLD : IpV6 PIM Snooping', u'hidden': u'full', u'callpoint': u'MldsVlan', u'cli-incomplete-no': None, u'alt-name': u'pim'}}, namespace='urn:brocade.com:mgmt:brocade-mld-snooping', defining_module='brocade-mld-snooping', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """mldPIM must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=mldPIM.mldPIM, is_container='container', yang_name="mldPIM", rest_name="pim", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'MLD : IpV6 PIM Snooping', u'hidden': u'full', u'callpoint': u'MldsVlan', u'cli-incomplete-no': None, u'alt-name': u'pim'}}, namespace='urn:brocade.com:mgmt:brocade-mld-snooping', defining_module='brocade-mld-snooping', yang_type='container', is_config=True)""",
        })

    self.__mldPIM = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_mldPIM(self):
    self.__mldPIM = YANGDynClass(base=mldPIM.mldPIM, is_container='container', yang_name="mldPIM", rest_name="pim", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'MLD : IpV6 PIM Snooping', u'hidden': u'full', u'callpoint': u'MldsVlan', u'cli-incomplete-no': None, u'alt-name': u'pim'}}, namespace='urn:brocade.com:mgmt:brocade-mld-snooping', defining_module='brocade-mld-snooping', yang_type='container', is_config=True)


  def _get_mldVlan(self):
    """
    Getter method for mldVlan, mapped from YANG variable /interface_vlan/vlan/ipv6/mldVlan (container)
    """
    return self.__mldVlan
      
  def _set_mldVlan(self, v, load=False):
    """
    Setter method for mldVlan, mapped from YANG variable /interface_vlan/vlan/ipv6/mldVlan (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_mldVlan is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_mldVlan() directly.
    """
    try:
      t = YANGDynClass(v,base=mldVlan.mldVlan, is_container='container', yang_name="mldVlan", rest_name="mld", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Multicast Listener Discovery (MLD) Snooping', u'hidden': u'full', u'callpoint': u'MldsVlan', u'cli-incomplete-no': None, u'alt-name': u'mld'}}, namespace='urn:brocade.com:mgmt:brocade-mld-snooping', defining_module='brocade-mld-snooping', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """mldVlan must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=mldVlan.mldVlan, is_container='container', yang_name="mldVlan", rest_name="mld", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Multicast Listener Discovery (MLD) Snooping', u'hidden': u'full', u'callpoint': u'MldsVlan', u'cli-incomplete-no': None, u'alt-name': u'mld'}}, namespace='urn:brocade.com:mgmt:brocade-mld-snooping', defining_module='brocade-mld-snooping', yang_type='container', is_config=True)""",
        })

    self.__mldVlan = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_mldVlan(self):
    self.__mldVlan = YANGDynClass(base=mldVlan.mldVlan, is_container='container', yang_name="mldVlan", rest_name="mld", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Multicast Listener Discovery (MLD) Snooping', u'hidden': u'full', u'callpoint': u'MldsVlan', u'cli-incomplete-no': None, u'alt-name': u'mld'}}, namespace='urn:brocade.com:mgmt:brocade-mld-snooping', defining_module='brocade-mld-snooping', yang_type='container', is_config=True)

  mldPIM = __builtin__.property(_get_mldPIM, _set_mldPIM)
  mldVlan = __builtin__.property(_get_mldVlan, _set_mldVlan)


  _pyangbind_elements = {'mldPIM': mldPIM, 'mldVlan': mldVlan, }


