
from operator import attrgetter
import pyangbind.lib.xpathhelper as xpathhelper
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType, RestrictedClassType, TypedListType
from pyangbind.lib.yangtypes import YANGBool, YANGListType, YANGDynClass, ReferenceType
from pyangbind.lib.base import PybindBase
from decimal import Decimal
from bitarray import bitarray
import __builtin__
import ipv4_route_entry
class ipv4_routes(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module brocade-isis-operational - based on the path /isis-state/ipv4-routes. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: ISIS IPv4 Route Table
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_rest_name', '_extmethods', '__total_routes_count','__ipv4_route_entry',)

  _yang_name = 'ipv4-routes'
  _rest_name = 'ipv4-routes'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    path_helper_ = kwargs.pop("path_helper", None)
    if path_helper_ is False:
      self._path_helper = False
    elif path_helper_ is not None and isinstance(path_helper_, xpathhelper.YANGPathHelper):
      self._path_helper = path_helper_
    elif hasattr(self, "_parent"):
      path_helper_ = getattr(self._parent, "_path_helper", False)
      self._path_helper = path_helper_
    else:
      self._path_helper = False

    extmethods = kwargs.pop("extmethods", None)
    if extmethods is False:
      self._extmethods = False
    elif extmethods is not None and isinstance(extmethods, dict):
      self._extmethods = extmethods
    elif hasattr(self, "_parent"):
      extmethods = getattr(self._parent, "_extmethods", None)
      self._extmethods = extmethods
    else:
      self._extmethods = False
    self.__total_routes_count = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="total-routes-count", rest_name="total-routes-count", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-isis-operational', defining_module='brocade-isis-operational', yang_type='uint32', is_config=False)
    self.__ipv4_route_entry = YANGDynClass(base=YANGListType("ipv4_dest_addr ipv4_subnet_mask ipv4_prefix_len",ipv4_route_entry.ipv4_route_entry, yang_name="ipv4-route-entry", rest_name="ipv4-route-entry", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='ipv4-dest-addr ipv4-subnet-mask ipv4-prefix-len', extensions={u'tailf-common': {u'callpoint': u'isis-ipv4-route', u'cli-suppress-show-path': None}}), is_container='list', yang_name="ipv4-route-entry", rest_name="ipv4-route-entry", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'callpoint': u'isis-ipv4-route', u'cli-suppress-show-path': None}}, namespace='urn:brocade.com:mgmt:brocade-isis-operational', defining_module='brocade-isis-operational', yang_type='list', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'isis-state', u'ipv4-routes']

  def _rest_path(self):
    if hasattr(self, "_parent"):
      if self._rest_name:
        return self._parent._rest_path()+[self._rest_name]
      else:
        return self._parent._rest_path()
    else:
      return [u'isis-state', u'ipv4-routes']

  def _get_total_routes_count(self):
    """
    Getter method for total_routes_count, mapped from YANG variable /isis_state/ipv4_routes/total_routes_count (uint32)

    YANG Description: Total number of IPv4 ISIS routes
    """
    return self.__total_routes_count
      
  def _set_total_routes_count(self, v, load=False):
    """
    Setter method for total_routes_count, mapped from YANG variable /isis_state/ipv4_routes/total_routes_count (uint32)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_total_routes_count is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_total_routes_count() directly.

    YANG Description: Total number of IPv4 ISIS routes
    """
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="total-routes-count", rest_name="total-routes-count", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-isis-operational', defining_module='brocade-isis-operational', yang_type='uint32', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """total_routes_count must be of a type compatible with uint32""",
          'defined-type': "uint32",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="total-routes-count", rest_name="total-routes-count", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-isis-operational', defining_module='brocade-isis-operational', yang_type='uint32', is_config=False)""",
        })

    self.__total_routes_count = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_total_routes_count(self):
    self.__total_routes_count = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="total-routes-count", rest_name="total-routes-count", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-isis-operational', defining_module='brocade-isis-operational', yang_type='uint32', is_config=False)


  def _get_ipv4_route_entry(self):
    """
    Getter method for ipv4_route_entry, mapped from YANG variable /isis_state/ipv4_routes/ipv4_route_entry (list)

    YANG Description: ISIS IPv4 Route Entry
    """
    return self.__ipv4_route_entry
      
  def _set_ipv4_route_entry(self, v, load=False):
    """
    Setter method for ipv4_route_entry, mapped from YANG variable /isis_state/ipv4_routes/ipv4_route_entry (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_ipv4_route_entry is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_ipv4_route_entry() directly.

    YANG Description: ISIS IPv4 Route Entry
    """
    try:
      t = YANGDynClass(v,base=YANGListType("ipv4_dest_addr ipv4_subnet_mask ipv4_prefix_len",ipv4_route_entry.ipv4_route_entry, yang_name="ipv4-route-entry", rest_name="ipv4-route-entry", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='ipv4-dest-addr ipv4-subnet-mask ipv4-prefix-len', extensions={u'tailf-common': {u'callpoint': u'isis-ipv4-route', u'cli-suppress-show-path': None}}), is_container='list', yang_name="ipv4-route-entry", rest_name="ipv4-route-entry", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'callpoint': u'isis-ipv4-route', u'cli-suppress-show-path': None}}, namespace='urn:brocade.com:mgmt:brocade-isis-operational', defining_module='brocade-isis-operational', yang_type='list', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """ipv4_route_entry must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("ipv4_dest_addr ipv4_subnet_mask ipv4_prefix_len",ipv4_route_entry.ipv4_route_entry, yang_name="ipv4-route-entry", rest_name="ipv4-route-entry", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='ipv4-dest-addr ipv4-subnet-mask ipv4-prefix-len', extensions={u'tailf-common': {u'callpoint': u'isis-ipv4-route', u'cli-suppress-show-path': None}}), is_container='list', yang_name="ipv4-route-entry", rest_name="ipv4-route-entry", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'callpoint': u'isis-ipv4-route', u'cli-suppress-show-path': None}}, namespace='urn:brocade.com:mgmt:brocade-isis-operational', defining_module='brocade-isis-operational', yang_type='list', is_config=False)""",
        })

    self.__ipv4_route_entry = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_ipv4_route_entry(self):
    self.__ipv4_route_entry = YANGDynClass(base=YANGListType("ipv4_dest_addr ipv4_subnet_mask ipv4_prefix_len",ipv4_route_entry.ipv4_route_entry, yang_name="ipv4-route-entry", rest_name="ipv4-route-entry", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='ipv4-dest-addr ipv4-subnet-mask ipv4-prefix-len', extensions={u'tailf-common': {u'callpoint': u'isis-ipv4-route', u'cli-suppress-show-path': None}}), is_container='list', yang_name="ipv4-route-entry", rest_name="ipv4-route-entry", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'callpoint': u'isis-ipv4-route', u'cli-suppress-show-path': None}}, namespace='urn:brocade.com:mgmt:brocade-isis-operational', defining_module='brocade-isis-operational', yang_type='list', is_config=False)

  total_routes_count = __builtin__.property(_get_total_routes_count)
  ipv4_route_entry = __builtin__.property(_get_ipv4_route_entry)


  _pyangbind_elements = {'total_routes_count': total_routes_count, 'ipv4_route_entry': ipv4_route_entry, }


