
from operator import attrgetter
import pyangbind.lib.xpathhelper as xpathhelper
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType, RestrictedClassType, TypedListType
from pyangbind.lib.yangtypes import YANGBool, YANGListType, YANGDynClass, ReferenceType
from pyangbind.lib.base import PybindBase
from decimal import Decimal
from bitarray import bitarray
import __builtin__
class rsvp_reservable_bandwidth(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module brocade-mpls - based on the path /mpls-config/router/mpls/mpls-cmds-holder/mpls-interface/rsvp/rsvp-reservable-bandwidth. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_rest_name', '_extmethods', '__reservable_bandwidth','__reservable_bandwidth_percentage',)

  _yang_name = 'rsvp-reservable-bandwidth'
  _rest_name = 'reservable-bandwidth'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    path_helper_ = kwargs.pop("path_helper", None)
    if path_helper_ is False:
      self._path_helper = False
    elif path_helper_ is not None and isinstance(path_helper_, xpathhelper.YANGPathHelper):
      self._path_helper = path_helper_
    elif hasattr(self, "_parent"):
      path_helper_ = getattr(self._parent, "_path_helper", False)
      self._path_helper = path_helper_
    else:
      self._path_helper = False

    extmethods = kwargs.pop("extmethods", None)
    if extmethods is False:
      self._extmethods = False
    elif extmethods is not None and isinstance(extmethods, dict):
      self._extmethods = extmethods
    elif hasattr(self, "_parent"):
      extmethods = getattr(self._parent, "_extmethods", None)
      self._extmethods = extmethods
    else:
      self._extmethods = False
    self.__reservable_bandwidth = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': [u'0..2000000000']}), is_leaf=True, yang_name="reservable-bandwidth", rest_name="", parent=self, choice=(u'rsvp-reservable-bandwidth-options', u'reservable-bandwidth-case-exact'), path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'cli-drop-node-name': None}}, namespace='urn:brocade.com:mgmt:brocade-mpls', defining_module='brocade-mpls', yang_type='uint32', is_config=True)
    self.__reservable_bandwidth_percentage = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': [u'0..100']}), is_leaf=True, yang_name="reservable-bandwidth-percentage", rest_name="percentage", parent=self, choice=(u'rsvp-reservable-bandwidth-options', u'reservable-bandwidth-case-percentage'), path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure Max reservable bandwidth as percentage', u'cli-full-command': None, u'alt-name': u'percentage'}}, namespace='urn:brocade.com:mgmt:brocade-mpls', defining_module='brocade-mpls', yang_type='uint32', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'mpls-config', u'router', u'mpls', u'mpls-cmds-holder', u'mpls-interface', u'rsvp', u'rsvp-reservable-bandwidth']

  def _rest_path(self):
    if hasattr(self, "_parent"):
      if self._rest_name:
        return self._parent._rest_path()+[self._rest_name]
      else:
        return self._parent._rest_path()
    else:
      return [u'router', u'mpls', u'mpls-interface', u'rsvp', u'reservable-bandwidth']

  def _get_reservable_bandwidth(self):
    """
    Getter method for reservable_bandwidth, mapped from YANG variable /mpls_config/router/mpls/mpls_cmds_holder/mpls_interface/rsvp/rsvp_reservable_bandwidth/reservable_bandwidth (uint32)
    """
    return self.__reservable_bandwidth
      
  def _set_reservable_bandwidth(self, v, load=False):
    """
    Setter method for reservable_bandwidth, mapped from YANG variable /mpls_config/router/mpls/mpls_cmds_holder/mpls_interface/rsvp/rsvp_reservable_bandwidth/reservable_bandwidth (uint32)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_reservable_bandwidth is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_reservable_bandwidth() directly.
    """
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': [u'0..2000000000']}), is_leaf=True, yang_name="reservable-bandwidth", rest_name="", parent=self, choice=(u'rsvp-reservable-bandwidth-options', u'reservable-bandwidth-case-exact'), path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'cli-drop-node-name': None}}, namespace='urn:brocade.com:mgmt:brocade-mpls', defining_module='brocade-mpls', yang_type='uint32', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """reservable_bandwidth must be of a type compatible with uint32""",
          'defined-type': "uint32",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': [u'0..2000000000']}), is_leaf=True, yang_name="reservable-bandwidth", rest_name="", parent=self, choice=(u'rsvp-reservable-bandwidth-options', u'reservable-bandwidth-case-exact'), path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'cli-drop-node-name': None}}, namespace='urn:brocade.com:mgmt:brocade-mpls', defining_module='brocade-mpls', yang_type='uint32', is_config=True)""",
        })

    self.__reservable_bandwidth = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_reservable_bandwidth(self):
    self.__reservable_bandwidth = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': [u'0..2000000000']}), is_leaf=True, yang_name="reservable-bandwidth", rest_name="", parent=self, choice=(u'rsvp-reservable-bandwidth-options', u'reservable-bandwidth-case-exact'), path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'cli-drop-node-name': None}}, namespace='urn:brocade.com:mgmt:brocade-mpls', defining_module='brocade-mpls', yang_type='uint32', is_config=True)


  def _get_reservable_bandwidth_percentage(self):
    """
    Getter method for reservable_bandwidth_percentage, mapped from YANG variable /mpls_config/router/mpls/mpls_cmds_holder/mpls_interface/rsvp/rsvp_reservable_bandwidth/reservable_bandwidth_percentage (uint32)
    """
    return self.__reservable_bandwidth_percentage
      
  def _set_reservable_bandwidth_percentage(self, v, load=False):
    """
    Setter method for reservable_bandwidth_percentage, mapped from YANG variable /mpls_config/router/mpls/mpls_cmds_holder/mpls_interface/rsvp/rsvp_reservable_bandwidth/reservable_bandwidth_percentage (uint32)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_reservable_bandwidth_percentage is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_reservable_bandwidth_percentage() directly.
    """
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': [u'0..100']}), is_leaf=True, yang_name="reservable-bandwidth-percentage", rest_name="percentage", parent=self, choice=(u'rsvp-reservable-bandwidth-options', u'reservable-bandwidth-case-percentage'), path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure Max reservable bandwidth as percentage', u'cli-full-command': None, u'alt-name': u'percentage'}}, namespace='urn:brocade.com:mgmt:brocade-mpls', defining_module='brocade-mpls', yang_type='uint32', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """reservable_bandwidth_percentage must be of a type compatible with uint32""",
          'defined-type': "uint32",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': [u'0..100']}), is_leaf=True, yang_name="reservable-bandwidth-percentage", rest_name="percentage", parent=self, choice=(u'rsvp-reservable-bandwidth-options', u'reservable-bandwidth-case-percentage'), path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure Max reservable bandwidth as percentage', u'cli-full-command': None, u'alt-name': u'percentage'}}, namespace='urn:brocade.com:mgmt:brocade-mpls', defining_module='brocade-mpls', yang_type='uint32', is_config=True)""",
        })

    self.__reservable_bandwidth_percentage = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_reservable_bandwidth_percentage(self):
    self.__reservable_bandwidth_percentage = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': [u'0..100']}), is_leaf=True, yang_name="reservable-bandwidth-percentage", rest_name="percentage", parent=self, choice=(u'rsvp-reservable-bandwidth-options', u'reservable-bandwidth-case-percentage'), path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure Max reservable bandwidth as percentage', u'cli-full-command': None, u'alt-name': u'percentage'}}, namespace='urn:brocade.com:mgmt:brocade-mpls', defining_module='brocade-mpls', yang_type='uint32', is_config=True)

  reservable_bandwidth = __builtin__.property(_get_reservable_bandwidth, _set_reservable_bandwidth)
  reservable_bandwidth_percentage = __builtin__.property(_get_reservable_bandwidth_percentage, _set_reservable_bandwidth_percentage)

  __choices__ = {u'rsvp-reservable-bandwidth-options': {u'reservable-bandwidth-case-percentage': [u'reservable_bandwidth_percentage'], u'reservable-bandwidth-case-exact': [u'reservable_bandwidth']}}
  _pyangbind_elements = {'reservable_bandwidth': reservable_bandwidth, 'reservable_bandwidth_percentage': reservable_bandwidth_percentage, }


