
from operator import attrgetter
import pyangbind.lib.xpathhelper as xpathhelper
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType, RestrictedClassType, TypedListType
from pyangbind.lib.yangtypes import YANGBool, YANGListType, YANGDynClass, ReferenceType
from pyangbind.lib.base import PybindBase
from decimal import Decimal
from bitarray import bitarray
import __builtin__
class rsvp_flooding_thresholds(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module brocade-mpls-operational - based on the path /mpls-state/policy/rsvp-flooding-thresholds. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: RSVP Flooding Threshold
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_rest_name', '_extmethods', '__threshold_type','__flooding_thresholds',)

  _yang_name = 'rsvp-flooding-thresholds'
  _rest_name = 'rsvp-flooding-thresholds'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    path_helper_ = kwargs.pop("path_helper", None)
    if path_helper_ is False:
      self._path_helper = False
    elif path_helper_ is not None and isinstance(path_helper_, xpathhelper.YANGPathHelper):
      self._path_helper = path_helper_
    elif hasattr(self, "_parent"):
      path_helper_ = getattr(self._parent, "_path_helper", False)
      self._path_helper = path_helper_
    else:
      self._path_helper = False

    extmethods = kwargs.pop("extmethods", None)
    if extmethods is False:
      self._extmethods = False
    elif extmethods is not None and isinstance(extmethods, dict):
      self._extmethods = extmethods
    elif hasattr(self, "_parent"):
      extmethods = getattr(self._parent, "_extmethods", None)
      self._extmethods = extmethods
    else:
      self._extmethods = False
    self.__threshold_type = YANGDynClass(base=unicode, is_leaf=True, yang_name="threshold-type", rest_name="threshold-type", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, is_keyval=True, namespace='urn:brocade.com:mgmt:brocade-mpls-operational', defining_module='brocade-mpls-operational', yang_type='string', is_config=False)
    self.__flooding_thresholds = YANGDynClass(base=TypedListType(allowed_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32)), is_leaf=False, yang_name="flooding-thresholds", rest_name="flooding-thresholds", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-mpls-operational', defining_module='brocade-mpls-operational', yang_type='uint32', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'mpls-state', u'policy', u'rsvp-flooding-thresholds']

  def _rest_path(self):
    if hasattr(self, "_parent"):
      if self._rest_name:
        return self._parent._rest_path()+[self._rest_name]
      else:
        return self._parent._rest_path()
    else:
      return [u'mpls-state', u'policy', u'rsvp-flooding-thresholds']

  def _get_threshold_type(self):
    """
    Getter method for threshold_type, mapped from YANG variable /mpls_state/policy/rsvp_flooding_thresholds/threshold_type (string)

    YANG Description: Type Of Threshold
    """
    return self.__threshold_type
      
  def _set_threshold_type(self, v, load=False):
    """
    Setter method for threshold_type, mapped from YANG variable /mpls_state/policy/rsvp_flooding_thresholds/threshold_type (string)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_threshold_type is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_threshold_type() directly.

    YANG Description: Type Of Threshold
    """
    parent = getattr(self, "_parent", None)
    if parent is not None and load is False:
      raise AttributeError("Cannot set keys directly when" +
                             " within an instantiated list")

    try:
      t = YANGDynClass(v,base=unicode, is_leaf=True, yang_name="threshold-type", rest_name="threshold-type", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, is_keyval=True, namespace='urn:brocade.com:mgmt:brocade-mpls-operational', defining_module='brocade-mpls-operational', yang_type='string', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """threshold_type must be of a type compatible with string""",
          'defined-type': "string",
          'generated-type': """YANGDynClass(base=unicode, is_leaf=True, yang_name="threshold-type", rest_name="threshold-type", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, is_keyval=True, namespace='urn:brocade.com:mgmt:brocade-mpls-operational', defining_module='brocade-mpls-operational', yang_type='string', is_config=False)""",
        })

    self.__threshold_type = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_threshold_type(self):
    self.__threshold_type = YANGDynClass(base=unicode, is_leaf=True, yang_name="threshold-type", rest_name="threshold-type", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, is_keyval=True, namespace='urn:brocade.com:mgmt:brocade-mpls-operational', defining_module='brocade-mpls-operational', yang_type='string', is_config=False)


  def _get_flooding_thresholds(self):
    """
    Getter method for flooding_thresholds, mapped from YANG variable /mpls_state/policy/rsvp_flooding_thresholds/flooding_thresholds (uint32)

    YANG Description: Flooding Thresholds
    """
    return self.__flooding_thresholds
      
  def _set_flooding_thresholds(self, v, load=False):
    """
    Setter method for flooding_thresholds, mapped from YANG variable /mpls_state/policy/rsvp_flooding_thresholds/flooding_thresholds (uint32)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_flooding_thresholds is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_flooding_thresholds() directly.

    YANG Description: Flooding Thresholds
    """
    try:
      t = YANGDynClass(v,base=TypedListType(allowed_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32)), is_leaf=False, yang_name="flooding-thresholds", rest_name="flooding-thresholds", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-mpls-operational', defining_module='brocade-mpls-operational', yang_type='uint32', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """flooding_thresholds must be of a type compatible with uint32""",
          'defined-type': "uint32",
          'generated-type': """YANGDynClass(base=TypedListType(allowed_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32)), is_leaf=False, yang_name="flooding-thresholds", rest_name="flooding-thresholds", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-mpls-operational', defining_module='brocade-mpls-operational', yang_type='uint32', is_config=False)""",
        })

    self.__flooding_thresholds = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_flooding_thresholds(self):
    self.__flooding_thresholds = YANGDynClass(base=TypedListType(allowed_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32)), is_leaf=False, yang_name="flooding-thresholds", rest_name="flooding-thresholds", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-mpls-operational', defining_module='brocade-mpls-operational', yang_type='uint32', is_config=False)

  threshold_type = __builtin__.property(_get_threshold_type)
  flooding_thresholds = __builtin__.property(_get_flooding_thresholds)


  _pyangbind_elements = {'threshold_type': threshold_type, 'flooding_thresholds': flooding_thresholds, }


