
from operator import attrgetter
import pyangbind.lib.xpathhelper as xpathhelper
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType, RestrictedClassType, TypedListType
from pyangbind.lib.yangtypes import YANGBool, YANGListType, YANGDynClass, ReferenceType
from pyangbind.lib.base import PybindBase
from decimal import Decimal
from bitarray import bitarray
import __builtin__
class auto_cost(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module brocade-common-def - based on the path /routing-system/ipv6/router/ospf/auto-cost. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Calculate OSPFv3 interface cost according to bandwidth
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_rest_name', '_extmethods', '__reference_bandwidth',)

  _yang_name = 'auto-cost'
  _rest_name = 'auto-cost'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    path_helper_ = kwargs.pop("path_helper", None)
    if path_helper_ is False:
      self._path_helper = False
    elif path_helper_ is not None and isinstance(path_helper_, xpathhelper.YANGPathHelper):
      self._path_helper = path_helper_
    elif hasattr(self, "_parent"):
      path_helper_ = getattr(self._parent, "_path_helper", False)
      self._path_helper = path_helper_
    else:
      self._path_helper = False

    extmethods = kwargs.pop("extmethods", None)
    if extmethods is False:
      self._extmethods = False
    elif extmethods is not None and isinstance(extmethods, dict):
      self._extmethods = extmethods
    elif hasattr(self, "_parent"):
      extmethods = getattr(self._parent, "_extmethods", None)
      self._extmethods = extmethods
    else:
      self._extmethods = False
    self.__reference_bandwidth = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': [u'1..4294967']}), is_leaf=True, yang_name="reference-bandwidth", rest_name="reference-bandwidth", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'info': u'Set OSPFv3  Auto-cost Reference-bandwidth in Mbits per second'}}, namespace='urn:brocade.com:mgmt:brocade-ospfv3', defining_module='brocade-ospfv3', yang_type='ospf:band-width', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'routing-system', u'ipv6', u'router', u'ospf', u'auto-cost']

  def _rest_path(self):
    if hasattr(self, "_parent"):
      if self._rest_name:
        return self._parent._rest_path()+[self._rest_name]
      else:
        return self._parent._rest_path()
    else:
      return [u'ipv6', u'router', u'ospf', u'auto-cost']

  def _get_reference_bandwidth(self):
    """
    Getter method for reference_bandwidth, mapped from YANG variable /routing_system/ipv6/router/ospf/auto_cost/reference_bandwidth (ospf:band-width)

    YANG Description: Each interface on which OSPFv3 is enabled has a cost associated with it. By default, OSPF cost of an interface is based on the port speed of the interface. The software uses the following formula to calculate the cost.Cost = reference-bandwidth/interface-speed
    """
    return self.__reference_bandwidth
      
  def _set_reference_bandwidth(self, v, load=False):
    """
    Setter method for reference_bandwidth, mapped from YANG variable /routing_system/ipv6/router/ospf/auto_cost/reference_bandwidth (ospf:band-width)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_reference_bandwidth is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_reference_bandwidth() directly.

    YANG Description: Each interface on which OSPFv3 is enabled has a cost associated with it. By default, OSPF cost of an interface is based on the port speed of the interface. The software uses the following formula to calculate the cost.Cost = reference-bandwidth/interface-speed
    """
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': [u'1..4294967']}), is_leaf=True, yang_name="reference-bandwidth", rest_name="reference-bandwidth", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'info': u'Set OSPFv3  Auto-cost Reference-bandwidth in Mbits per second'}}, namespace='urn:brocade.com:mgmt:brocade-ospfv3', defining_module='brocade-ospfv3', yang_type='ospf:band-width', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """reference_bandwidth must be of a type compatible with ospf:band-width""",
          'defined-type': "ospf:band-width",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': [u'1..4294967']}), is_leaf=True, yang_name="reference-bandwidth", rest_name="reference-bandwidth", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'info': u'Set OSPFv3  Auto-cost Reference-bandwidth in Mbits per second'}}, namespace='urn:brocade.com:mgmt:brocade-ospfv3', defining_module='brocade-ospfv3', yang_type='ospf:band-width', is_config=True)""",
        })

    self.__reference_bandwidth = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_reference_bandwidth(self):
    self.__reference_bandwidth = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': [u'1..4294967']}), is_leaf=True, yang_name="reference-bandwidth", rest_name="reference-bandwidth", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'info': u'Set OSPFv3  Auto-cost Reference-bandwidth in Mbits per second'}}, namespace='urn:brocade.com:mgmt:brocade-ospfv3', defining_module='brocade-ospfv3', yang_type='ospf:band-width', is_config=True)

  reference_bandwidth = __builtin__.property(_get_reference_bandwidth, _set_reference_bandwidth)


  _pyangbind_elements = {'reference_bandwidth': reference_bandwidth, }


