
from operator import attrgetter
import pyangbind.lib.xpathhelper as xpathhelper
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType, RestrictedClassType, TypedListType
from pyangbind.lib.yangtypes import YANGBool, YANGListType, YANGDynClass, ReferenceType
from pyangbind.lib.base import PybindBase
from decimal import Decimal
from bitarray import bitarray
import __builtin__
class log_adjacency(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module brocade-common-def - based on the path /routing-system/ipv6/router/ospf/log/log-adjacency. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configure logging for adjacency changes
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_rest_name', '_extmethods', '__log_adjacency_dr_only',)

  _yang_name = 'log-adjacency'
  _rest_name = 'adjacency'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    path_helper_ = kwargs.pop("path_helper", None)
    if path_helper_ is False:
      self._path_helper = False
    elif path_helper_ is not None and isinstance(path_helper_, xpathhelper.YANGPathHelper):
      self._path_helper = path_helper_
    elif hasattr(self, "_parent"):
      path_helper_ = getattr(self._parent, "_path_helper", False)
      self._path_helper = path_helper_
    else:
      self._path_helper = False

    extmethods = kwargs.pop("extmethods", None)
    if extmethods is False:
      self._extmethods = False
    elif extmethods is not None and isinstance(extmethods, dict):
      self._extmethods = extmethods
    elif hasattr(self, "_parent"):
      extmethods = getattr(self._parent, "_extmethods", None)
      self._extmethods = extmethods
    else:
      self._extmethods = False
    self.__log_adjacency_dr_only = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="log-adjacency-dr-only", rest_name="dr-only", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'info': u"Logging only Designated Router interfaces' adjacency changes", u'alt-name': u'dr-only'}}, namespace='urn:brocade.com:mgmt:brocade-ospfv3', defining_module='brocade-ospfv3', yang_type='empty', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'routing-system', u'ipv6', u'router', u'ospf', u'log', u'log-adjacency']

  def _rest_path(self):
    if hasattr(self, "_parent"):
      if self._rest_name:
        return self._parent._rest_path()+[self._rest_name]
      else:
        return self._parent._rest_path()
    else:
      return [u'ipv6', u'router', u'ospf', u'log', u'adjacency']

  def _get_log_adjacency_dr_only(self):
    """
    Getter method for log_adjacency_dr_only, mapped from YANG variable /routing_system/ipv6/router/ospf/log/log_adjacency/log_adjacency_dr_only (empty)
    """
    return self.__log_adjacency_dr_only
      
  def _set_log_adjacency_dr_only(self, v, load=False):
    """
    Setter method for log_adjacency_dr_only, mapped from YANG variable /routing_system/ipv6/router/ospf/log/log_adjacency/log_adjacency_dr_only (empty)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_log_adjacency_dr_only is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_log_adjacency_dr_only() directly.
    """
    try:
      t = YANGDynClass(v,base=YANGBool, is_leaf=True, yang_name="log-adjacency-dr-only", rest_name="dr-only", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'info': u"Logging only Designated Router interfaces' adjacency changes", u'alt-name': u'dr-only'}}, namespace='urn:brocade.com:mgmt:brocade-ospfv3', defining_module='brocade-ospfv3', yang_type='empty', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """log_adjacency_dr_only must be of a type compatible with empty""",
          'defined-type': "empty",
          'generated-type': """YANGDynClass(base=YANGBool, is_leaf=True, yang_name="log-adjacency-dr-only", rest_name="dr-only", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'info': u"Logging only Designated Router interfaces' adjacency changes", u'alt-name': u'dr-only'}}, namespace='urn:brocade.com:mgmt:brocade-ospfv3', defining_module='brocade-ospfv3', yang_type='empty', is_config=True)""",
        })

    self.__log_adjacency_dr_only = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_log_adjacency_dr_only(self):
    self.__log_adjacency_dr_only = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="log-adjacency-dr-only", rest_name="dr-only", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'info': u"Logging only Designated Router interfaces' adjacency changes", u'alt-name': u'dr-only'}}, namespace='urn:brocade.com:mgmt:brocade-ospfv3', defining_module='brocade-ospfv3', yang_type='empty', is_config=True)

  log_adjacency_dr_only = __builtin__.property(_get_log_adjacency_dr_only, _set_log_adjacency_dr_only)


  _pyangbind_elements = {'log_adjacency_dr_only': log_adjacency_dr_only, }


