
from operator import attrgetter
import pyangbind.lib.xpathhelper as xpathhelper
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType, RestrictedClassType, TypedListType
from pyangbind.lib.yangtypes import YANGBool, YANGListType, YANGDynClass, ReferenceType
from pyangbind.lib.base import PybindBase
from decimal import Decimal
from bitarray import bitarray
import __builtin__
import lif_statistics
class bridge_domain_statistics(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module brocade-nsm-operational - based on the path /sub-interface-statistics-state/bridge-domain-statistics. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: bridge-domain statistics
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_rest_name', '_extmethods', '__bd_id','__lif_statistics',)

  _yang_name = 'bridge-domain-statistics'
  _rest_name = 'bridge-domain-statistics'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    path_helper_ = kwargs.pop("path_helper", None)
    if path_helper_ is False:
      self._path_helper = False
    elif path_helper_ is not None and isinstance(path_helper_, xpathhelper.YANGPathHelper):
      self._path_helper = path_helper_
    elif hasattr(self, "_parent"):
      path_helper_ = getattr(self._parent, "_path_helper", False)
      self._path_helper = path_helper_
    else:
      self._path_helper = False

    extmethods = kwargs.pop("extmethods", None)
    if extmethods is False:
      self._extmethods = False
    elif extmethods is not None and isinstance(extmethods, dict):
      self._extmethods = extmethods
    elif hasattr(self, "_parent"):
      extmethods = getattr(self._parent, "_extmethods", None)
      self._extmethods = extmethods
    else:
      self._extmethods = False
    self.__lif_statistics = YANGDynClass(base=YANGListType("lif_id",lif_statistics.lif_statistics, yang_name="lif-statistics", rest_name="lif-statistics", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='lif-id', extensions={u'tailf-common': {u'callpoint': u'nsm-lif-statistics', u'cli-suppress-show-path': None}}), is_container='list', yang_name="lif-statistics", rest_name="lif-statistics", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'callpoint': u'nsm-lif-statistics', u'cli-suppress-show-path': None}}, namespace='urn:brocade.com:mgmt:brocade-nsm-operational', defining_module='brocade-nsm-operational', yang_type='list', is_config=False)
    self.__bd_id = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="bd-id", rest_name="bd-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, is_keyval=True, namespace='urn:brocade.com:mgmt:brocade-nsm-operational', defining_module='brocade-nsm-operational', yang_type='uint32', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'sub-interface-statistics-state', u'bridge-domain-statistics']

  def _rest_path(self):
    if hasattr(self, "_parent"):
      if self._rest_name:
        return self._parent._rest_path()+[self._rest_name]
      else:
        return self._parent._rest_path()
    else:
      return [u'sub-interface-statistics-state', u'bridge-domain-statistics']

  def _get_bd_id(self):
    """
    Getter method for bd_id, mapped from YANG variable /sub_interface_statistics_state/bridge_domain_statistics/bd_id (uint32)

    YANG Description: bridge-domain index
    """
    return self.__bd_id
      
  def _set_bd_id(self, v, load=False):
    """
    Setter method for bd_id, mapped from YANG variable /sub_interface_statistics_state/bridge_domain_statistics/bd_id (uint32)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_bd_id is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_bd_id() directly.

    YANG Description: bridge-domain index
    """
    parent = getattr(self, "_parent", None)
    if parent is not None and load is False:
      raise AttributeError("Cannot set keys directly when" +
                             " within an instantiated list")

    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="bd-id", rest_name="bd-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, is_keyval=True, namespace='urn:brocade.com:mgmt:brocade-nsm-operational', defining_module='brocade-nsm-operational', yang_type='uint32', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """bd_id must be of a type compatible with uint32""",
          'defined-type': "uint32",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="bd-id", rest_name="bd-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, is_keyval=True, namespace='urn:brocade.com:mgmt:brocade-nsm-operational', defining_module='brocade-nsm-operational', yang_type='uint32', is_config=False)""",
        })

    self.__bd_id = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_bd_id(self):
    self.__bd_id = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="bd-id", rest_name="bd-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, is_keyval=True, namespace='urn:brocade.com:mgmt:brocade-nsm-operational', defining_module='brocade-nsm-operational', yang_type='uint32', is_config=False)


  def _get_lif_statistics(self):
    """
    Getter method for lif_statistics, mapped from YANG variable /sub_interface_statistics_state/bridge_domain_statistics/lif_statistics (list)

    YANG Description: lif statistics
    """
    return self.__lif_statistics
      
  def _set_lif_statistics(self, v, load=False):
    """
    Setter method for lif_statistics, mapped from YANG variable /sub_interface_statistics_state/bridge_domain_statistics/lif_statistics (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_lif_statistics is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_lif_statistics() directly.

    YANG Description: lif statistics
    """
    try:
      t = YANGDynClass(v,base=YANGListType("lif_id",lif_statistics.lif_statistics, yang_name="lif-statistics", rest_name="lif-statistics", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='lif-id', extensions={u'tailf-common': {u'callpoint': u'nsm-lif-statistics', u'cli-suppress-show-path': None}}), is_container='list', yang_name="lif-statistics", rest_name="lif-statistics", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'callpoint': u'nsm-lif-statistics', u'cli-suppress-show-path': None}}, namespace='urn:brocade.com:mgmt:brocade-nsm-operational', defining_module='brocade-nsm-operational', yang_type='list', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """lif_statistics must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("lif_id",lif_statistics.lif_statistics, yang_name="lif-statistics", rest_name="lif-statistics", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='lif-id', extensions={u'tailf-common': {u'callpoint': u'nsm-lif-statistics', u'cli-suppress-show-path': None}}), is_container='list', yang_name="lif-statistics", rest_name="lif-statistics", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'callpoint': u'nsm-lif-statistics', u'cli-suppress-show-path': None}}, namespace='urn:brocade.com:mgmt:brocade-nsm-operational', defining_module='brocade-nsm-operational', yang_type='list', is_config=False)""",
        })

    self.__lif_statistics = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_lif_statistics(self):
    self.__lif_statistics = YANGDynClass(base=YANGListType("lif_id",lif_statistics.lif_statistics, yang_name="lif-statistics", rest_name="lif-statistics", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='lif-id', extensions={u'tailf-common': {u'callpoint': u'nsm-lif-statistics', u'cli-suppress-show-path': None}}), is_container='list', yang_name="lif-statistics", rest_name="lif-statistics", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'callpoint': u'nsm-lif-statistics', u'cli-suppress-show-path': None}}, namespace='urn:brocade.com:mgmt:brocade-nsm-operational', defining_module='brocade-nsm-operational', yang_type='list', is_config=False)

  bd_id = __builtin__.property(_get_bd_id)
  lif_statistics = __builtin__.property(_get_lif_statistics)


  _pyangbind_elements = {'bd_id': bd_id, 'lif_statistics': lif_statistics, }


