
from operator import attrgetter
import pyangbind.lib.xpathhelper as xpathhelper
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType, RestrictedClassType, TypedListType
from pyangbind.lib.yangtypes import YANGBool, YANGListType, YANGDynClass, ReferenceType
from pyangbind.lib.base import PybindBase
from decimal import Decimal
from bitarray import bitarray
import __builtin__
import vc_peer_data
class vc_peer_state(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module brocade-pwm-operational - based on the path /vc-peer-state. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description:  VC peer information
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_rest_name', '_extmethods', '__vc_peer_data',)

  _yang_name = 'vc-peer-state'
  _rest_name = 'vc-peer-state'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    path_helper_ = kwargs.pop("path_helper", None)
    if path_helper_ is False:
      self._path_helper = False
    elif path_helper_ is not None and isinstance(path_helper_, xpathhelper.YANGPathHelper):
      self._path_helper = path_helper_
    elif hasattr(self, "_parent"):
      path_helper_ = getattr(self._parent, "_path_helper", False)
      self._path_helper = path_helper_
    else:
      self._path_helper = False

    extmethods = kwargs.pop("extmethods", None)
    if extmethods is False:
      self._extmethods = False
    elif extmethods is not None and isinstance(extmethods, dict):
      self._extmethods = extmethods
    elif hasattr(self, "_parent"):
      extmethods = getattr(self._parent, "_extmethods", None)
      self._extmethods = extmethods
    else:
      self._extmethods = False
    self.__vc_peer_data = YANGDynClass(base=YANGListType("vc_id",vc_peer_data.vc_peer_data, yang_name="vc-peer-data", rest_name="vc-peer-data", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='vc-id', extensions={u'tailf-common': {u'callpoint': u'pwm-vc-peer-data', u'cli-suppress-show-path': None}}), is_container='list', yang_name="vc-peer-data", rest_name="vc-peer-data", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'callpoint': u'pwm-vc-peer-data', u'cli-suppress-show-path': None}}, namespace='urn:brocade.com:mgmt:brocade-pwm-operational', defining_module='brocade-pwm-operational', yang_type='list', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'vc-peer-state']

  def _rest_path(self):
    if hasattr(self, "_parent"):
      if self._rest_name:
        return self._parent._rest_path()+[self._rest_name]
      else:
        return self._parent._rest_path()
    else:
      return [u'vc-peer-state']

  def _get_vc_peer_data(self):
    """
    Getter method for vc_peer_data, mapped from YANG variable /vc_peer_state/vc_peer_data (list)

    YANG Description:  VC peer
    """
    return self.__vc_peer_data
      
  def _set_vc_peer_data(self, v, load=False):
    """
    Setter method for vc_peer_data, mapped from YANG variable /vc_peer_state/vc_peer_data (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_vc_peer_data is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_vc_peer_data() directly.

    YANG Description:  VC peer
    """
    try:
      t = YANGDynClass(v,base=YANGListType("vc_id",vc_peer_data.vc_peer_data, yang_name="vc-peer-data", rest_name="vc-peer-data", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='vc-id', extensions={u'tailf-common': {u'callpoint': u'pwm-vc-peer-data', u'cli-suppress-show-path': None}}), is_container='list', yang_name="vc-peer-data", rest_name="vc-peer-data", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'callpoint': u'pwm-vc-peer-data', u'cli-suppress-show-path': None}}, namespace='urn:brocade.com:mgmt:brocade-pwm-operational', defining_module='brocade-pwm-operational', yang_type='list', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """vc_peer_data must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("vc_id",vc_peer_data.vc_peer_data, yang_name="vc-peer-data", rest_name="vc-peer-data", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='vc-id', extensions={u'tailf-common': {u'callpoint': u'pwm-vc-peer-data', u'cli-suppress-show-path': None}}), is_container='list', yang_name="vc-peer-data", rest_name="vc-peer-data", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'callpoint': u'pwm-vc-peer-data', u'cli-suppress-show-path': None}}, namespace='urn:brocade.com:mgmt:brocade-pwm-operational', defining_module='brocade-pwm-operational', yang_type='list', is_config=False)""",
        })

    self.__vc_peer_data = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_vc_peer_data(self):
    self.__vc_peer_data = YANGDynClass(base=YANGListType("vc_id",vc_peer_data.vc_peer_data, yang_name="vc-peer-data", rest_name="vc-peer-data", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='vc-id', extensions={u'tailf-common': {u'callpoint': u'pwm-vc-peer-data', u'cli-suppress-show-path': None}}), is_container='list', yang_name="vc-peer-data", rest_name="vc-peer-data", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'callpoint': u'pwm-vc-peer-data', u'cli-suppress-show-path': None}}, namespace='urn:brocade.com:mgmt:brocade-pwm-operational', defining_module='brocade-pwm-operational', yang_type='list', is_config=False)

  vc_peer_data = __builtin__.property(_get_vc_peer_data)


  _pyangbind_elements = {'vc_peer_data': vc_peer_data, }


